/*
   This file is copyright (c) 1986 by William Couture.  All rights reserved.

   GREATLY! Modified for CODEGEN, V1.1
*/


#include <compiler.h>
#include <codegen.h>
#include <regstruc.h>
#include <opdefs.h>

#define FLAG_MASK_8088 0xF000
#define BIT_3_ON '\010'   /* bit 3 */
#define BIT_3_OFF '\367'  /* bit 3 */
#define BIT_0_OFF  '\376'   /* bit 0 */
#define BIT_0_ON  '\001'  /* bit 0 */
/*
   I do not have the time to totally comment all functions in this file.  For
   more information, check out an 8088/8086 reference manual.  For information
   on how the flags are done, see the file asmfns.c.

   There are some comments in here, however, so do not overlook this file.
*/

/*
   NOTE:  The usual check for a BYTE/WORD instruction is:
      if (instruction.flags & BYTE)
   The lack of a BYTE flag is taken to mean a word flag.
*/

extern union regunion regs;
extern union regunion regvalues;

extern union regflags regsknown;

extern struct optable instruction;

extern struct tofrom dest,source;

extern unsigned int prefix;
extern unsigned int memok;
extern unsigned int segoffset;

extern int mod,reg,rm;

extern unsigned char byte_one;  /* from VIM.C */

unsigned int fetchbyte(),fetchword();

void db()  /* A null routine to stick a pointer to. */
   {
   }

void ax_unk()
   {
   regsknown.wordknown[0] = FALSE;
   }


void adc()
   {
   if (dest.where & REG)
      if (instruction.flags & BYTE)
         {
         regsknown.byteknown[dest.reg] = FALSE;
         }
      else
         {
         regsknown.wordknown[dest.reg] = FALSE;
         }
   }

void add()
   {
   if (instruction.flags & BYTE)
      {
      if (dest.where & REG)
         {
         if (regsknown.byteknown[dest.reg])
            {
            if ((source.where & REG) && (regsknown.byteknown[source.reg]))
               regvalues.bytearray[dest.reg] += regvalues.bytearray[source.reg];
            else
               if (instruction.source == SDATA8)
                  regvalues.bytearray[dest.reg] += source.value;
               else
                  regsknown.byteknown[dest.reg] = FALSE;
            }
         }
      }
   else
      {
      if (dest.where & REG)
         {
         if (regsknown.wordknown[dest.reg] == W_TRUE)
            {
            if ((source.where & REG) && (regsknown.wordknown[source.reg] == W_TRUE))
               regvalues.wordarray[dest.reg] += regvalues.wordarray[source.reg];
            else
               if ((instruction.source == SXDATA8)
                                     || (instruction.source == SDATA16))
                  regvalues.wordarray[dest.reg] += source.value;
               else
                  regsknown.wordknown[dest.reg] = FALSE;
            }
         else
            regsknown.wordknown[dest.reg] = FALSE;  /* make sure both bytes unknown */
         }
      }
   }

void and()
   {
   if (instruction.flags & BYTE)
      {
      if (dest.where & REG)
         {
         if (regsknown.byteknown[dest.reg])
            {
            if ((source.where & REG) && (regsknown.byteknown[source.reg]))
               regvalues.bytearray[dest.reg] &= regvalues.bytearray[source.reg];
            else
               if (instruction.source == SDATA8)
                  regvalues.bytearray[dest.reg] &= source.value;
               else
                  regsknown.byteknown[dest.reg] = FALSE;
            }
         }
      }
   else
      {
      if (dest.where & REG)
         {
         if (regsknown.wordknown[dest.reg] == W_TRUE)
            {
            if ((source.where & REG) && (regsknown.wordknown[source.reg] == W_TRUE))
               regvalues.wordarray[dest.reg] &= regvalues.wordarray[source.reg];
            else
               if ((instruction.source == SXDATA8)
                                     || (instruction.source == SDATA16))
                  regvalues.wordarray[dest.reg] &= source.value;
               else
                  regsknown.wordknown[dest.reg] = FALSE;
            }
         else
            regsknown.wordknown[dest.reg] = FALSE;  /* make sure both bytes unknown */
         }
      }
   }

void sp_unk()
   {
   regsknown.wordknown[4] = FALSE;
   }

void cbw()
   {
   if (regsknown.byteknown[0])
      {
      if (regvalues.r.ax.byte.al & SIGNEDB)
         regvalues.r.ax.byte.ah = 0xff;
      else
         regvalues.r.ax.byte.ah = 0;
      regsknown.byteknown[1] = TRUE;
      }
   else
      regsknown.byteknown[1] = FALSE;
   }

void cwd()
   {
   if (regsknown.byteknown[1] == TRUE)  /* need only know AH */
      {
      if (regvalues.r.ax.word & SIGNEDW)
         regvalues.r.dx.word = 0xffff;
      else
         regvalues.r.dx.word = 0;
      regsknown.wordknown[2] = W_TRUE;  /* 2 = DX */
      }
   else
      regsknown.wordknown[2] = FALSE;
   }

void al_unk()
   {
   regsknown.byteknown[0] = FALSE;
   }

void cmpsb()
   {
   regsknown.wordknown[6] = FALSE;  /* si unknown */
   regsknown.wordknown[7] = FALSE;  /* di unknown */
   if (prefix & REP)
      regsknown.wordknown[1] = FALSE;  /* cx unknown */
   }

void cmpsw()
   {
   regsknown.wordknown[6] = FALSE;  /* si unknown */
   regsknown.wordknown[7] = FALSE;  /* di unknown */
   if (prefix & REP)
      regsknown.wordknown[1] = FALSE;  /* cx unknown */
   }

void dec()
   {
   if (instruction.flags & BYTE)
      {
      if (dest.where & REG)
         if (regsknown.byteknown[dest.reg])
            regvalues.bytearray[dest.reg]--;
      }
   else
      {
      if (dest.where & REG)
         if (regsknown.wordknown[dest.reg] == W_TRUE)
            regvalues.wordarray[dest.reg]--;
         else
            regsknown.wordknown[dest.reg] = FALSE;  /* make sure both bytes unknown */
      }
   }

void div()
   {
   UNSIGNED_LONG temp1,temp2,ul_div(),ul_mod();

   temp1 = 0x10000L;  /* default to no good */
   temp2 = 0;
   if (instruction.flags & BYTE)
      {
      if ((regsknown.wordknown[0] == W_TRUE)
                     && (source.where & REG)
                     && (regsknown.byteknown[source.reg]))
         {
         if (source.value = regvalues.bytearray[source.reg])
            {
            temp1 = regvalues.r.ax.word / source.value;
            temp2 = regvalues.r.ax.word % source.value;
            }
         }
      if (temp1 > 0xffL)  /* divide by zero or unk */
         regsknown.wordknown[0] = FALSE;  /* AL and AH unknown! */
      else
         {
         regvalues.r.ax.byte.al = temp1;
         regvalues.r.ax.byte.ah = temp2;
         regsknown.wordknown[0] = W_TRUE;
         }
      }
   else
      {
      if ((regsknown.wordknown[0] == W_TRUE)
                    && (regsknown.wordknown[2] == W_TRUE)
                    && (source.where & REG)
                    && (regsknown.wordknown[source.reg] == W_TRUE))
         {
         if (source.value = regvalues.wordarray[source.reg])
            {
            temp1 = regvalues.r.dx.word;
            temp1 <<= 16;
            temp1 += regvalues.r.ax.word;
            temp2 = temp1;
            temp1 = ul_div(temp1,source.value);
            temp2 = ul_mod(temp2,source.value);
            }
         }
      if (temp1 > 0xffffL)  /* divide by 0 trap */
         {
         regsknown.wordknown[0] = FALSE;  /* AX unknown! */
         regsknown.wordknown[2] = FALSE;  /* DX unknown! */
         }
      else
         {
         regvalues.r.ax.word = temp1;
         regvalues.r.dx.word = temp2;
         }
      }
   }

void idiv()
   {
   long temp1,temp2;

   temp1 = 0x10000L;  /* default to no good */
   temp2 = 0;
   if (instruction.flags & BYTE)
      {
      if ((regsknown.wordknown[0] == W_TRUE)
                     && (source.where & REG)
                     && (regsknown.byteknown[source.reg]))
         {
         if (source.value = regvalues.bytearray[source.reg])
            {
            if (source.value & 0x80L)
               source.value |= 0xff00L;  /* sign extend to get proper signed
                               result.  May have problems on your compiler. */
            if (regvalues.r.ax.word & SIGNEDW)
               temp1 = 0xffff0000L | regvalues.r.ax.word;
            else
               temp1 = regvalues.r.ax.word;
            temp2 = temp1;
            temp1 /= source.value;
            temp2 %= source.value;
            }
         }
      if (temp1 > 0x7fL)  /* divide by 0 trap */
         regsknown.wordknown[0] = FALSE;  /* AL and AH unknown! */
      else
         {
         regvalues.r.ax.byte.al = temp1;
         regvalues.r.ax.byte.ah = temp2;
         regsknown.wordknown[0] = W_TRUE;
         }
      }
   else
      {
      if ((regsknown.wordknown[0] == W_TRUE)
                    && (regsknown.wordknown[2] == W_TRUE)
                    && (source.where & REG)
                    && (regsknown.wordknown[source.reg] == W_TRUE))
         {
         if (source.value = regvalues.wordarray[source.reg])
            {
            if (source.value & 0x8000L)
               source.value |= 0xffff0000L;  /* Sign extension again.
                                                Watch it! */
            temp1 = regvalues.r.dx.word;
            temp1 <<= 16;
            temp1 += regvalues.r.ax.word;
            temp2 = temp1;
            temp1 /= source.value;
            temp2 %= source.value;
            }
         }
      if (temp1 > 0x7fffL)  /* divide by 0 trap */
         {
         regsknown.wordknown[0] = FALSE;  /* AX unknown! */
         regsknown.wordknown[2] = FALSE;  /* DX unknown! */
         }
      else
         {
         regvalues.r.ax.word = temp1;
         regvalues.r.dx.word = temp2;
         }
      }
   }

void imul()
   {
   long temp;

   if ((byte_one & '\375') == '\151')  /* if IMUL immediate */
      {
      if (regsknown.wordknown[source.reg] == W_TRUE)
         {
         regvalues.wordarray[reg] =
                    (int)(((int)regvalues.wordarray[source.reg])
                                * ((int)dest.value));
         regsknown.wordknown[reg] = W_TRUE;
         }
      else
         regsknown.wordknown[reg] = FALSE;
      }
   else
      {
      if (instruction.flags & BYTE)
         {
         if ((regsknown.byteknown[0])
                      && (source.where & REG)
                      && (regsknown.byteknown[source.reg]))
            {
            source.value = regvalues.bytearray[source.reg];
            if (source.value & 0x80L)
               source.value |= 0xff00L;
            if (regvalues.r.ax.byte.al & SIGNEDB)
               temp = 0xff00L | regvalues.r.ax.byte.al;
            else
               temp = regvalues.r.ax.byte.al;
            temp *= source.value;
            regvalues.r.ax.byte.al = temp & 0xffL;
            regvalues.r.ax.byte.ah = (temp >> 8) & 0xffL;
            regsknown.wordknown[0] = W_TRUE;
            }
         else
            regsknown.wordknown[0] = FALSE;
         }
      else
         {
         if ((regsknown.wordknown[0] == W_TRUE) && (source.where & REG)
                && (regsknown.wordknown[source.reg] == W_TRUE))
            {
            if (source.value & 0x8000L)
               source.value |= 0xffff0000L;
            if (regvalues.r.ax.word & SIGNEDW)
               temp = 0xffff0000L | regvalues.r.ax.word;
            else
               temp = regvalues.r.ax.word;
            temp *= source.value;
            regvalues.r.ax.word = temp & 0xffffL;
            regvalues.r.dx.word = (temp >> 16) & 0xffffL;
            regsknown.wordknown[0] = W_TRUE;
            regsknown.wordknown[2] = W_TRUE;
            }
         else
            {
            regsknown.wordknown[0] = FALSE;
            regsknown.wordknown[2] = FALSE;
            }
         }
      }
   }

void in()
   {
   if (instruction.flags & BYTE)
      regsknown.byteknown[0] = FALSE;
   else
      regsknown.wordknown[0] = FALSE;
   }

void inc()
   {
   if (instruction.flags & BYTE)
      {
      if (dest.where & REG)
         if (regsknown.byteknown[dest.reg])
            regvalues.bytearray[dest.reg]++;
      }
   else
      {
      if (dest.where & REG)
         if (regsknown.wordknown[dest.reg] == W_TRUE)
            regvalues.wordarray[dest.reg]++;
         else
            regsknown.wordknown[dest.reg] = FALSE;  /* make sure both bytes unknown */
      }
   }

void insb()
   {
   regsknown.wordknown[7] = FALSE;  /* di unknown */
   regsknown.byteknown[0] = FALSE;  /* al unknown */
   if (prefix & REP)
      {
      regsknown.wordknown[1] = W_TRUE;  /* cx known */
      regvalues.wordarray[1] = 0;       /* after a repeat, CX is 0 */
      }
   }

void insw()
   {
   regsknown.wordknown[7] = FALSE;  /* di unknown */
   regsknown.wordknown[0] = FALSE;  /* ax unknown */
   if (prefix & REP)
      {
      regsknown.wordknown[1] = W_TRUE;  /* cx known */
      regvalues.wordarray[1] = 0;       /* after a repeat, CX is 0 */
      }
   }

void allunk()
   {
   REGS_UNKNOWN;
   }

void lahf()
   {
   regsknown.byteknown[1] = FALSE;
   }

void lds()
   {
   regsknown.wordknown[dest.reg] = FALSE;
   regsknown.wordknown[11] = FALSE;  /* ds unknown */
   }

void lea()
   {

   unsigned int whichregs,holdofs,temp,valid;

   temp =
   holdofs =
   whichregs = 0;  /* no registers used.  bx=1, bp=2, si=4, di=8 */
   valid = TRUE;
   switch(rm)  /* get addressing mode */
      {
      case 0:
         holdofs = regvalues.r.bx.word + regvalues.r.si;
         temp = regs.r.bx.word + regs.r.si;
         whichregs = 5;
         break;
      case 1:
         holdofs = regvalues.r.bx.word + regvalues.r.di;
         temp = regs.r.bx.word + regs.r.di;
         whichregs = 9;
         break;
      case 2:
         holdofs = regvalues.r.bp + regvalues.r.si;
         temp = regs.r.bp + regs.r.si;
         whichregs = 6;
         break;
      case 3:
         holdofs = regvalues.r.bp + regvalues.r.di;
         temp = regs.r.bp + regs.r.di;
         whichregs = 10;
         break;
      case 4:
         holdofs = regvalues.r.si;
         temp = regs.r.si;
         whichregs = 4;
         break;
      case 5:
         holdofs = regvalues.r.di;
         temp = regs.r.di;
         whichregs = 8;
         break;
      case 6:
         if (mod)
            {
            holdofs = regvalues.r.bp;
            temp = regs.r.bp;
            whichregs = 2;
            }
         break;
      case 7:
         holdofs = regvalues.r.bx.word;
         temp = regs.r.bx;
         whichregs = 1;
         break;
      }
   if ((whichregs & 1) && (regsknown.wordknown[3] != W_TRUE))
      valid = FALSE;
   if ((whichregs & 2) && (regsknown.wordknown[5] != W_TRUE))
      valid = FALSE;
   if ((whichregs & 4) && (regsknown.wordknown[6] != W_TRUE))
      valid = FALSE;
   if ((whichregs & 8) && (regsknown.wordknown[7] != W_TRUE))
      valid = FALSE;
   if (valid)
      {
      source.ofs -= temp;
      source.ofs += holdofs;
      regvalues.wordarray[dest.reg] = source.ofs;
      regsknown.wordknown[dest.reg] = W_TRUE;
      }
   else
      regsknown.wordknown[dest.reg] = FALSE;
   }

void les()
   {
   regsknown.wordknown[dest.reg] = FALSE;
   regsknown.wordknown[8] = FALSE;  /* es unknown */
   }

void lodsb()
   {
   regsknown.wordknown[6] = FALSE;  /* si unknown */
   regsknown.byteknown[0] = FALSE;  /* al unknown */
   if (prefix & REP)
      {
      regsknown.wordknown[1] = W_TRUE;  /* cx known */
      regvalues.wordarray[1] = 0;       /* after a repeat, CX is 0 */
      }
   }

void lodsw()
   {
   regsknown.wordknown[6] = FALSE;  /* si unknown */
   regsknown.wordknown[0] = FALSE;  /* ax unknown */
   if (prefix & REP)
      {
      regsknown.wordknown[1] = W_TRUE;  /* cx known */
      regvalues.wordarray[1] = 0;       /* after a repeat, CX is 0 */
      }
   }

void loop()
   {
   if (regsknown.wordknown[1] == W_TRUE)
      regvalues.r.cx.word--;
   else
      regsknown.wordknown[1] = FALSE;  /* make sure both bytes unknown */
   }

void loopnz()
   {
   if (regsknown.wordknown[1] == W_TRUE)
      regvalues.r.cx.word--;
   else
      regsknown.wordknown[1] = FALSE;  /* make sure both bytes unknown */
   }

void loopz()
   {
   if (regsknown.wordknown[1] == W_TRUE)
      regvalues.r.cx.word--;
   else
      regsknown.wordknown[1] = FALSE;  /* make sure both bytes unknown */
   }

void mov()
   {
   if (instruction.flags & BYTE)
      {
      if (dest.where & REG)
         {
         if ((source.where & REG) && (regsknown.byteknown[source.reg]))
            {
            regvalues.bytearray[dest.reg] = regvalues.bytearray[source.reg];
            regsknown.byteknown[dest.reg] = TRUE;
            }
         else
            {
            if (instruction.source == SDATA8)
               {
               regvalues.bytearray[dest.reg] = source.value;
               regsknown.byteknown[dest.reg] = TRUE;
               }
            else
               regsknown.byteknown[dest.reg] = FALSE;
            }
         }
      }
   else
      {
      if (dest.where & REG)
         {
         regvalues.wordarray[dest.reg] = source.value;
         if ((source.where & REG) && (regsknown.wordknown[source.reg] == W_TRUE))
            {
            regvalues.wordarray[dest.reg] = regvalues.wordarray[source.reg];
            regsknown.wordknown[dest.reg] = W_TRUE;
            }
         else
            {
            if (instruction.source == SDATA16)
               {
               regvalues.wordarray[dest.reg] = source.value;
               regsknown.wordknown[dest.reg] = W_TRUE;
               }
            else
               regsknown.wordknown[dest.reg] = FALSE;
            }
/*       regvalues.wordarray[dest.reg] = source.value;  TEMPORARILY REMOVED! */
         }
      }
   }

void movsb()
   {
   regsknown.wordknown[6] = FALSE;  /* si unknown */
   regsknown.wordknown[7] = FALSE;  /* di unknown */
   if (prefix & REP)
      {
      regsknown.wordknown[1] = W_TRUE;  /* cx known */
      regvalues.wordarray[1] = 0;       /* after a repeat, CX is 0 */
      }
   }

void movsw()
   {
   regsknown.wordknown[6] = FALSE;  /* si unknown */
   regsknown.wordknown[7] = FALSE;  /* di unknown */
   if (prefix & REP)
      {
      regsknown.wordknown[1] = W_TRUE;  /* cx known */
      regvalues.wordarray[1] = 0;       /* after a repeat, CX is 0 */
      }
   }


void mul()
   {
   long temp;

   if (instruction.flags & BYTE)
      {
      if ((regsknown.byteknown[0])
                   && (source.where & REG)
                   && (regsknown.byteknown[source.reg]))
         {
         temp = regvalues.r.ax.byte.al * regvalues.bytearray[source.reg];
         regvalues.r.ax.byte.al = temp & 0xffL;
         regvalues.r.ax.byte.ah = (temp >> 8) & 0xffL;
         regsknown.wordknown[0] = W_TRUE;
         }
      else
         regsknown.wordknown[0] = FALSE;
      }
   else
      {
      if ((regsknown.wordknown[0] == W_TRUE) && (source.where & REG)
             && (regsknown.wordknown[source.reg] == W_TRUE))
         {
         temp = regvalues.r.ax.word * regvalues.wordarray[source.reg];
         regvalues.r.ax.word = temp & 0xffffL;
         regvalues.r.dx.word = (temp >> 16) & 0xffffL;
         regsknown.wordknown[0] = W_TRUE;
         regsknown.wordknown[2] = W_TRUE;
         }
      else
         {
         regsknown.wordknown[0] = FALSE;
         regsknown.wordknown[2] = FALSE;
         }
      }
   }

void neg()
   {
   if (instruction.flags & BYTE)
      {
      if ((dest.where & REG) && (regsknown.byteknown[dest.reg]))
         regvalues.bytearray[dest.reg] = -regvalues.bytearray[dest.reg];
      }
   else
      {
      if (dest.where & REG)
         if (regsknown.wordknown[dest.reg] == W_TRUE)
            regvalues.wordarray[dest.reg] = -regvalues.wordarray[dest.reg];
         else
            regsknown.wordknown[dest.reg] = FALSE;  /* make sure both bytes unknown */
      }
   }

void nop()
   {
   }

void not()
   {
   if (instruction.flags & BYTE)
      {
      if ((dest.where & REG) && (regsknown.byteknown[dest.reg]))
         regvalues.bytearray[dest.reg] = ~regvalues.bytearray[dest.reg];
      }
   else
      {
      if (dest.where & REG)
         if (regsknown.wordknown[dest.reg] == W_TRUE)
            regvalues.wordarray[dest.reg] = ~regvalues.wordarray[dest.reg];
         else
            regsknown.wordknown[dest.reg] = FALSE;  /* make sure both bytes unknown */
      }
   }

void or()
   {
   if (instruction.flags & BYTE)
      {
      if (dest.where & REG)
         {
         if (regsknown.byteknown[dest.reg])
            {
            if ((source.where & REG) && (regsknown.byteknown[source.reg]))
               regvalues.bytearray[dest.reg] |= regvalues.bytearray[source.reg];
            else
               if (instruction.source == SDATA8)
                  regvalues.bytearray[dest.reg] |= source.value;
               else
                  regsknown.byteknown[dest.reg] = FALSE;
            }
         }
      }
   else
      {
      if (dest.where & REG)
         {
         if (regsknown.wordknown[dest.reg] == W_TRUE)
            {
            if ((source.where & REG) && (regsknown.wordknown[source.reg] == W_TRUE))
               regvalues.wordarray[dest.reg] |= regvalues.wordarray[source.reg];
            else
               if ((instruction.source == SXDATA8)
                                     || (instruction.source == SDATA16))
                  regvalues.wordarray[dest.reg] |= source.value;
               else
                  regsknown.wordknown[dest.reg] = FALSE;
            }
         else
            regsknown.wordknown[dest.reg] = FALSE;  /* make sure both bytes unknown */
         }
      }
   }

void outsb()
   {
   regsknown.wordknown[6] = FALSE;  /* si unknown */
   if (prefix & REP)
      {
      regsknown.wordknown[1] = W_TRUE;  /* cx known */
      regvalues.wordarray[1] = 0;       /* after a repeat, CX is 0 */
      }
   }
   
void outsw()
   {
   regsknown.wordknown[6] = FALSE;  /* si unknown */
   if (prefix & REP)
      {
      regsknown.wordknown[1] = W_TRUE;  /* cx known */
      regvalues.wordarray[1] = 0;       /* after a repeat, CX is 0 */
      }
   }

void pop()
   {
   if (dest.where & REG)
      regsknown.wordknown[dest.reg] = FALSE;
   regvalues.r.sp += 2;
   }

void popa()  /* support some additional 80286 instructions */
   {
   regsknown.wordknown[0] =
   regsknown.wordknown[1] =
   regsknown.wordknown[2] =
   regsknown.wordknown[3] =
   regsknown.wordknown[5] =
   regsknown.wordknown[6] =
   regsknown.wordknown[7] = FALSE;
   regvalues.r.sp += 16;
   }

void popf()
   {
   regvalues.r.sp += 2;
   }

void push()
   {
   regvalues.r.sp -= 2;
   }

void pusha()
   {
   regvalues.r.sp -= 16;
   }

void pushf()
   {
   regvalues.r.sp -= 2;
   }

void rcl()
   {
   if (instruction.flags & BYTE)
      {
      if (dest.where & REG)
         regsknown.byteknown[dest.reg] = FALSE;
      }
   else
      {
      if (dest.where & REG)
         regsknown.wordknown[dest.reg] = FALSE;
      }
   }
   
void rcr()
   {
   if (instruction.flags & BYTE)
      {
      if (dest.where & REG)
         regsknown.byteknown[dest.reg] = FALSE;
      }
   else
      {
      if (dest.where & REG)
         regsknown.wordknown[dest.reg] = FALSE;
      }
   }

void rol()
   {
   unsigned int temp,wrapflag,tempflag;

   if (dest.where & REG)
      {
      tempflag = TRUE;
      if (instruction.flags & (NOCOUNT+COUNT))  /* if no flags, then immediate */
         {
         if (instruction.flags & NOCOUNT)
            temp = 1;
         else
            {
            temp = regvalues.r.cx.byte.cl;
            tempflag = FALSE;
            }
         }
      else
         temp = source.value;
      if ((tempflag) || (regsknown.byteknown[2]))  /* if count or cl known */
         {
         if (instruction.flags & BYTE)
            {
            if (regsknown.byteknown[dest.reg])
               {
               dest.value = regvalues.bytearray[dest.reg];
               while (temp--)
                  {
                  if (dest.value & 0x80L)
                     {
                     wrapflag = 1;
                     }
                  else
                     {
                     wrapflag = 0;
                     }
                  dest.value = (dest.value << 1) + wrapflag;
                  }
               regvalues.bytearray[dest.reg] = dest.value;
               }
            }
         else
            {
            if (regsknown.wordknown[dest.reg] == W_TRUE)
               {
               dest.value = regvalues.wordarray[dest.reg];
               while (temp--)
                  {
                  if (dest.value & 0x8000L)
                     {
                     wrapflag = 1;
                     }
                  else
                     {
                     wrapflag = 0;
                     }
                  dest.value = (dest.value << 1) + wrapflag;
                  }
               regvalues.wordarray[dest.reg] = dest.value;
               }
            else
               regsknown.wordknown[dest.reg] = FALSE;  /* make sure both bytes unknown */
            }
         }
      else
         {
         if (instruction.flags & BYTE)
            regsknown.byteknown[dest.reg] = FALSE;
         else
            regsknown.wordknown[dest.reg] = FALSE;
         }
      }
   }

void ror()
   {
   unsigned int temp,wrapflag,tempflag;

   if (dest.where & REG)
      {
      tempflag = TRUE;
      if (instruction.flags & (NOCOUNT+COUNT))  /* if no flags, then immediate */
         {
         if (instruction.flags & NOCOUNT)
            temp = 1;
         else
            {
            temp = regvalues.r.cx.byte.cl;
            tempflag = FALSE;
            }
         }
      else
         temp = source.value;
      if ((tempflag) || (regsknown.byteknown[2]))  /* if count or cl known */
         {
         if (instruction.flags & BYTE)
            {
            if (regsknown.byteknown[dest.reg])
               {
               dest.value = regvalues.bytearray[dest.reg];
               while (temp--)
                  {
                  if (dest.value & 1)
                     {
                     wrapflag = SIGNEDB;
                     }
                  else
                     {
                     wrapflag = 0;
                     }
                  dest.value = ((dest.value >> 1) & 0x7fL) + wrapflag;
                  }
               regvalues.bytearray[dest.reg] = dest.value;
               }
            }
         else
            {
            if (regsknown.wordknown[dest.reg] == W_TRUE)
               {
               dest.value = regvalues.wordarray[dest.reg];
               while (temp--)
                  {
                  if (dest.value & 1)
                     {
                     wrapflag = SIGNEDW;
                     }
                  else
                     {
                     wrapflag = 0;
                     }
                  dest.value = ((dest.value >> 1) & 0x7fffL) + wrapflag;
                  }
               regvalues.wordarray[dest.reg] = dest.value;
               }
            else
               regsknown.wordknown[dest.reg] = FALSE;  /* make sure both bytes unknown */
            }
         }
      else
         {
         if (instruction.flags & BYTE)
            regsknown.byteknown[dest.reg] = FALSE;
         else
            regsknown.wordknown[dest.reg] = FALSE;
         }
      }
   }

void sar()
   {
   unsigned int temp,signflag,tempflag;

   if (dest.where & REG)
      {
      tempflag = TRUE;
      if (instruction.flags & (NOCOUNT+COUNT))  /* if no flags, then immediate */
         {
         if (instruction.flags & NOCOUNT)
            temp = 1;
         else
            {
            temp = regvalues.r.cx.byte.cl;
            tempflag = FALSE;
            }
         }
      else
         temp = source.value;
      if ((tempflag) || (regsknown.byteknown[2]))  /* if count or cl known */
         {
         if (instruction.flags & BYTE)
            {
            if (regsknown.byteknown[dest.reg])
               {
               dest.value = regvalues.bytearray[dest.reg];
               while (temp--)
                  {
                  signflag = dest.value & 0x80L;
                  dest.value = ((dest.value >> 1) & 0x7fL) + signflag;
                  }
               regvalues.bytearray[dest.reg] = dest.value;
               }
            }
         else
            {
            if (regsknown.wordknown[dest.reg] == W_TRUE)
               {
               dest.value = regvalues.wordarray[dest.reg];
               while (temp--)
                  {
                  signflag = dest.value & 0x8000L;
                  dest.value = ((dest.value >> 1) & 0x7fffL) + signflag;
                  }
               regvalues.wordarray[dest.reg] = dest.value;
               }
            else
               regsknown.wordknown[dest.reg] = FALSE;  /* make sure both bytes unknown */
            }
         }
      else
         {
         if (instruction.flags & BYTE)
            regsknown.byteknown[dest.reg] = FALSE;
         else
            regsknown.wordknown[dest.reg] = FALSE;
         }
      }
   }

void sbb()
   {
   if (dest.where & REG)
      if (instruction.flags & BYTE)
         {
         regsknown.byteknown[dest.reg] = FALSE;
         }
      else
         {
         regsknown.wordknown[dest.reg] = FALSE;
         }
   }

void scasb()
   {
   regsknown.wordknown[7] = FALSE;  /* di unknown */
   if (prefix & REP)
      regsknown.wordknown[1] = FALSE;  /* cx unknown */
   }

void scasw()
   {
   regsknown.wordknown[7] = FALSE;  /* di unknown */
   if (prefix & REP)
      regsknown.wordknown[1] = FALSE;  /* cx unknown */
   }

void shl()
   {
   unsigned int temp,tempflag;

   if (dest.where & REG)
      {
      tempflag = TRUE;
      if (instruction.flags & (NOCOUNT+COUNT))  /* if no flags, then immediate */
         {
         if (instruction.flags & NOCOUNT)
            temp = 1;
         else
            {
            temp = regvalues.r.cx.byte.cl;
            tempflag = FALSE;
            }
         }
      else
         temp = source.value;
      if ((tempflag) || (regsknown.byteknown[2]))  /* if count or cl known */
         {
         if (instruction.flags & BYTE)
            {
            if (regsknown.byteknown[dest.reg])
               {
               dest.value = regvalues.bytearray[dest.reg];
               while (temp--)
                  {
                  dest.value <<= 1;
                  }
               regvalues.bytearray[dest.reg] = dest.value;
               }
            }
         else
            {
            if (regsknown.wordknown[dest.reg] == W_TRUE)
               {
               dest.value = regvalues.wordarray[dest.reg];
               while (temp--)
                  {
                  dest.value <<= 1;
                  }
               regvalues.wordarray[dest.reg] = dest.value;
               }
            else
               regsknown.wordknown[dest.reg] = FALSE;  /* make sure both bytes unknown */
            }
         }
      else
         {
         if (instruction.flags & BYTE)
            regsknown.byteknown[dest.reg] = FALSE;
         else
            regsknown.wordknown[dest.reg] = FALSE;
         }
      }
   }

void shr()
   {
   unsigned int temp,tempflag;

   if (dest.where & REG)
      {
      tempflag = TRUE;
      if (instruction.flags & (NOCOUNT+COUNT))  /* if no flags, then immediate */
         {
         if (instruction.flags & NOCOUNT)
            temp = 1;
         else
            {
            temp = regvalues.r.cx.byte.cl;
            tempflag = FALSE;
            }
         }
      else
         temp = source.value;
      if ((tempflag) || (regsknown.byteknown[2]))  /* if count or cl known */
         {
         if (instruction.flags & BYTE)
            {
            if (regsknown.byteknown[dest.reg])
               {
               dest.value = regvalues.bytearray[dest.reg];
               while (temp--)
                  {
                  dest.value = (dest.value >> 1) & 0x7fL;
                  }
               regvalues.bytearray[dest.reg] = dest.value;
               }
            }
         else
            {
            if (regsknown.wordknown[dest.reg] == W_TRUE)
               {
               dest.value = regvalues.wordarray[dest.reg];
               while (temp--)
                  {
                  dest.value = (dest.value >> 1) & 0x7fffL;
                  }
               regvalues.wordarray[dest.reg] = dest.value;
               }
            else
               regsknown.wordknown[dest.reg] = FALSE;  /* make sure both bytes unknown */
            }
         }
      else
         {
         if (instruction.flags & BYTE)
            regsknown.byteknown[dest.reg] = FALSE;
         else
            regsknown.wordknown[dest.reg] = FALSE;
         }
      }
   }

void stosb()
   {
   regsknown.wordknown[7] = FALSE;  /* di unknown */
   if (prefix & REP)
      {
      regsknown.wordknown[1] = W_TRUE;  /* cx known */
      regvalues.wordarray[1] = 0;       /* after a repeat, CX is 0 */
      }
   }

void stosw()
   {
   regsknown.wordknown[7] = FALSE;  /* di unknown */
   if (prefix & REP)
      {
      regsknown.wordknown[1] = W_TRUE;  /* cx known */
      regvalues.wordarray[1] = 0;       /* after a repeat, CX is 0 */
      }
   }

void sub()
   {
   if (instruction.flags & BYTE)
      {
      if (dest.where & REG)
         {
         if ((source.where & REG) && (dest.reg == source.reg))
            {
            regvalues.bytearray[dest.reg] = 0;
            regsknown.byteknown[dest.reg] = TRUE;
            }
         else
            if (regsknown.byteknown[dest.reg])
               {
               if ((source.where & REG) && (regsknown.byteknown[source.reg]))
                  regvalues.bytearray[dest.reg] -= regvalues.bytearray[source.reg];
               else
                  if (instruction.source == SDATA8)
                     regvalues.bytearray[dest.reg] -= source.value;
                  else
                     regsknown.byteknown[dest.reg] = FALSE;
               }
         }
      }
   else
      {
      if (dest.where & REG)
         {
         if ((source.where & REG) && (dest.reg == source.reg))
            {
            regvalues.wordarray[dest.reg] = 0;
            regsknown.wordknown[dest.reg] = W_TRUE;
            }
         else
            if (regsknown.wordknown[dest.reg] == W_TRUE)
               {
               if ((source.where & REG) && (regsknown.wordknown[source.reg] == W_TRUE))
                  regvalues.wordarray[dest.reg] -= regvalues.wordarray[source.reg];
               else
                  if ((instruction.source == SXDATA8)
                                        || (instruction.source == SDATA16))
                     regvalues.wordarray[dest.reg] -= source.value;
                  else
                     regsknown.wordknown[dest.reg] = FALSE;
               }
            else
               regsknown.wordknown[dest.reg] = FALSE;  /* make sure both bytes unknown */
         }
      }
   }

void xchg()
   {
   unsigned int tempval,tempknown;

   if (instruction.flags & BYTE)
      {
      if (dest.where & REG)
         {
         if (source.where & REG)
            {
            tempval = regvalues.bytearray[dest.reg];
            tempknown = regsknown.byteknown[dest.reg];
            regvalues.bytearray[dest.reg] = regvalues.bytearray[source.reg];
            regsknown.byteknown[dest.reg] = regsknown.byteknown[source.reg];
            regvalues.bytearray[source.reg] = tempval;
            regsknown.byteknown[source.reg] = tempknown;
            }
         else
            regsknown.byteknown[dest.reg] = FALSE;
         }
      }
   else
      {
      if (dest.where & REG)
         {
         if (source.where & REG)
            {
            tempval = regvalues.wordarray[dest.reg];
            tempknown = regsknown.wordknown[dest.reg];
            regvalues.wordarray[dest.reg] = regvalues.wordarray[source.reg];
            regsknown.wordknown[dest.reg] = regsknown.wordknown[source.reg];
            regvalues.wordarray[source.reg] = tempval;
            regsknown.wordknown[source.reg] = tempknown;
            }
         else
            regsknown.wordknown[dest.reg] = FALSE;
         }
      }
   }

void xor()
   {
   if (instruction.flags & BYTE)
      {
      if (dest.where & REG)
         {
         if ((source.where & REG) && (dest.reg == source.reg))
            {
            regvalues.bytearray[dest.reg] = 0;
            regsknown.byteknown[dest.reg] = TRUE;
            }
         else
            if (regsknown.byteknown[dest.reg])
               {
               if ((source.where & REG) && (regsknown.byteknown[source.reg]))
                  regvalues.bytearray[dest.reg] ^= regvalues.bytearray[source.reg];
               else
                  if (instruction.source == SDATA8)
                     regvalues.bytearray[dest.reg] ^= source.value;
                  else
                     regsknown.byteknown[dest.reg] = FALSE;
               }
         }
      }
   else
      {
      if (dest.where & REG)
         {
         if ((source.where & REG) && (dest.reg == source.reg))
            {
            regvalues.wordarray[dest.reg] = 0;
            regsknown.wordknown[dest.reg] = W_TRUE;
            }
         else
            if (regsknown.wordknown[dest.reg] == W_TRUE)
               {
               if ((source.where & REG) && (regsknown.wordknown[source.reg] == W_TRUE))
                  regvalues.wordarray[dest.reg] ^= regvalues.wordarray[source.reg];
               else
                  if ((instruction.source == SXDATA8)
                                        || (instruction.source == SDATA16))
                     regvalues.wordarray[dest.reg] ^= source.value;
                  else
                     regsknown.wordknown[dest.reg] = FALSE;
               }
            else
               regsknown.wordknown[dest.reg] = FALSE;  /* make sure both bytes unknown */
         }
      }
   }

/*
   This is where the array of pointers to functions is set up.  Note that
   the order is the SAME as that of the opnames array, and that the
   indexing is keyed to the defines in OPDEFS.H.
   THEY MUST BE KEPT THAT WAY!  IF YOU CHANGE ANY OF THEM YOU MUST CHANGE
   THEM ALL!

   That the order is the same as the order of the routines above reflects
   bookkeeping while writing the routines.  They do not have to be in
   order, but think of the poor programmer after you!
*/
/*  This is the original array
void (*opfns[113])() = {
db,    aaa,   aad,   aam,
aas,   adc,   add,   and,
bound, call,  callf, cbw,
clc,   cld,   cli,   cmc,
cmp,   cmpsb, cmpsw, cwd,
daa,   das,   dec,   div,
enter, esc,   hlt,   idiv,
imul,  in,    inc,   insb,
insw,  intr,  into,  iret,
ja,    jae,   jcxz,  jg,
jge,   jmp,   jmpf,  jna,
jnae,  jng,   jnge,  jno,
jns,   jnz,   jo,    jpe,
jpo,   js,    jz,    lahf,
lds,   lea,   leave, les,
lock,  lodsb, lodsw, loop,
loopz, loopnz,mov,   movsb,
movsw, mul,   neg,   nop,
not,   or,    out,   outsb,
outsw, pop,   popa,  popf,
push,  pusha, pushf, rcl,
rcr,   repz,  repnz, ret,
retf,  rol,   ror,   sahf,
sar,   sbb,   scasb, scasw,
segcs, segds, seges, segss,
shl,   shr,   stc,   std,
sti,   stosb, stosw, sub,
test,  wait,  xchg,  xlat,
xor
   };
*/
void (*opfns[129])() = {
db,    ax_unk,ax_unk,ax_unk,
ax_unk,adc,   add,   and,
nop,   allunk,allunk,cbw,
nop,   nop,   nop,   nop,
nop,   cmpsb, cmpsw, cwd,
al_unk,al_unk,dec,   div,
allunk,nop,   nop,   idiv,
imul,  in,    inc,   insb,
insw,  allunk,allunk,allunk,
nop,   nop,   nop,   nop,
nop,   nop,   nop,   nop,
nop,   nop,   nop,   nop,
nop,   nop,   nop,   nop,
nop,   nop,   nop,   lahf,
lds,   lea,   allunk,les,
nop,   lodsb, lodsw, loop,
loopz, loopnz,mov,   movsb,
movsw, mul,   neg,   nop,
not,   or,    nop,   outsb,
outsw, pop,   popa,  popf,
push,  pusha, pushf, rcl,
rcr,   nop,   nop,   allunk,
allunk,rol,   ror,   nop,
sar,   sbb,   scasb, scasw,
nop,   nop,   nop,   nop,
shl,   shr,   nop,   nop,
nop,   stosb, stosw, sub,
nop,   nop,   xchg,  al_unk,
xor,
/*
   80286 PM instuctions, not in alphabetical order
*/
adc,   adc,   adc,   nop,   /* ARPL,  SLDT,  STR,   LLDT */
nop,   nop,   nop,   nop,   /* LTR,   VERR,  VERW,  SGDT */
nop,   nop,   nop,   adc,   /* SIDT,  LGDT,  LIDT,  SMSW */
nop,   adc,   adc,   nop    /* LMSW,  LAR,   LSL,   CLTS */
        /*
           Note: adc() is used as it sets destination register to unknown.
        */
   };
