/*
   This file is copyright (c) 1988 by William Couture.  All rights reserved.
*/
#include <compiler.h>  /* Makes the source code more transportable */
#include <codegen.h>
#include <regstruc.h>
#include <opdefs.h>

extern union regunion regs;  /* See the regstruc.h file for details */
extern struct tofrom dest,source;
extern struct cgmap_header cgm_header;

extern struct optable instruction;
extern struct optable firstbyte[256];
extern struct optable secondbyte[15][8];
extern struct optable extended_186_instrs[20];
extern struct optable normal_firstbyte_0f;
extern struct optable undef_instr;
extern struct optable extended_shl_instr;
extern struct optable extended_firstbyte_0f;

extern union regunion regvalues;  /* for function call determination */
extern union regflags regsknown;  /* regs known or unknown */
extern void (*opfns[113])();  /* register tracking functions */

extern struct symbol_table symbols[SYM_TABLE_SIZE];
extern unsigned int num_syms;  /* how many symbols are used */

extern struct call_addr noret_call_addrs[NUM_NORET_CALL_ADDRS+1];
extern unsigned int num_call_addrs;  /* 0 = none, else index */

extern unsigned int num_ints_to_comment;
extern struct int_offsets ints_to_comment[NUM_ROM_INTS];

extern char regnames[23][3];  /* register names (i.e. AX, BX, CH, etc) */

extern unsigned char instr[150];  /* decoded instruction string */
extern unsigned char prefix_str[150];  /* the prefix string */
extern unsigned char globalstr[150];  /* global temporary string */
extern unsigned char filename[80];  /* allow for paths */
extern unsigned char mapname[80];
extern unsigned char outfile[80];
extern unsigned char search_str[80];  /* search pattern */
extern unsigned char diskbuf[DISKBUF_SIZE];

extern unsigned int segoffset;  /* virtual relocation segment */
extern unsigned int mapspace;  /* segment used to hold the byte map of the program */
extern unsigned int codemap;  /* map segment corresponding to the code space */
extern unsigned int datamap;  /* map segment corresponding to the data space */
extern unsigned int memtop,memused;  /* used and available data segments */

extern unsigned int do_term_tracking;  /* need to do register tracking for DOS
                                          program termination */

extern unsigned int use_term_char;  /* use 0 as part of string */
extern unsigned int term_char;

extern unsigned int highseg;  /* CS or SS, whichever is higher */
extern unsigned int lowseg;   /* CS or SS, whichever is lower */

extern unsigned int progstart;   /* load address of the program */
extern unsigned int progend;     /* load address plus length of program */
extern unsigned int load_offset;  /* offset to load program at */
extern unsigned int memory_model;  /* 0=.COM, 1=normal .EXE, 2= cs=ds .EXE */
extern unsigned int file_type;  /* 0 = COM, 1 = EXE, 2 = DEVICE */
extern unsigned int cpu_type;  /* 0 = 8086, 1 = 80186, 2 = 80286 */
extern unsigned int reloc_ds;  /* the SS value to use for an .EXE file */
extern unsigned int startloc;  /* starting IP value */

extern unsigned int myfputsok;  /* output to file is OK */
extern unsigned int pagepause;  /* pause on pages during Preview */
extern unsigned int linecount;  /* count of lines for pause */

extern unsigned int string_search;  /* true or false */
extern unsigned int string_found;
extern unsigned int search_ip;  /* starting IP for this line */
extern unsigned int find_str_len;

extern unsigned int use_offset_mask;  /* mask out or keep PROG_OFFSET bit */

extern unsigned int prefix;  /* global info on the current prefix instructions */

extern unsigned int parse_seg;  /* default segment for parse_seg_and_ofs() */

extern int fileout;                /* the output file */
extern int mod,reg,rm;  /* EA byte fields, set by decode() and decodens() */

extern unsigned int startip;  /* share starting IP with decode() */

extern int xref_index;
extern int xref_file;
extern int do_xref;
extern int skip_short_xref;
extern unsigned int skip_short_xref_dist;

extern unsigned char nl_str[];
extern unsigned char onechar[];
extern unsigned char esc_to_quit_msg[];
extern unsigned char ill_addr_msg[];
extern unsigned char ill_sym_msg[];
extern unsigned char num_sym_msg[];
extern unsigned char sym_tab_full_msg[];
extern unsigned char sym_tab_empty_msg[];
extern unsigned char sym_addr_instr1[];
extern unsigned char sym_addr_instr2[];
extern unsigned char sym_addr_instr3[];
extern unsigned char sym_addr_instr4[];
extern unsigned char enter_sym_addr_msg[];
extern unsigned char ending_ofs_msg[];
extern unsigned char no_match_sym_msg[];
extern unsigned char ill_resp_msg[];
extern unsigned char ask_option[];
extern unsigned char start_loc_msg[];
extern unsigned char start_loc_2_msg[];
extern unsigned char which_seg_msg[];
extern unsigned char end_loc_msg[];
extern unsigned char end_loc_msg_2[];

extern unsigned int byte,flag,count,keyin;  /* some misc stuff */

char cgm_signature[4] = "cgm";  /* all 4 bytes significant */

unsigned int fetchbyte();  /* fetch a byte from virtual memory */

long lseek();

void onoroff(flag,end_flag)
   int flag,end_flag;
   {
   if (flag)
      puts(" ON");
   else
      puts(" OFF");
   if (end_flag)
      puts(")\n");
   }

int read_map(name)
   char *name;
   {
   int count,numin,filein,flag,pos;
   unsigned int seg,ofs;
   char tempstr[150];


   filein = open(name,MODE_READ);  /* should be able to open it again! */
   flag = FALSE;
   if (read(filein,&cgm_header,sizeof(struct cgmap_header))
                                            != sizeof(struct cgmap_header))
      flag = TRUE;
   else
      {
      if (strcmp(cgm_header.signature,cgm_signature))
         flag = TRUE;
      }
   if (flag)
      return(FALSE);
   if (cgm_header.flagword & CGM_FLAG_INTADDR)
      {
      lseek(filein,(long)(sizeof(struct cgmap_header)),0);
      read(filein,&pos,2);  /* get ofs to int information */
      lseek(filein,(long)pos,0);
      read(filein,&num_ints_to_comment,2);
      read(filein,ints_to_comment,num_ints_to_comment * sizeof(struct int_offset));
      }
   if (cgm_header.flagword & CGM_FLAG_PROCESSOR)
      {
      lseek(filein,(long)(sizeof(struct cgmap_header))+2L,0);
      read(filein,&cpu_type,2);  /* get CPU type */
      }
   else
      cpu_type = 1;  /* if does not exist, old map file - need 80186 */
   set_processor_level(cpu_type);
   seg = mapspace;
   ofs = 0;
   lseek(filein,(long)cgm_header.map_ofs,0);  /* seek to start of map */
   flag = TRUE;
   do
      {
      if (numin = read(filein,diskbuf,DISKBUF_SIZE))
         {
         for (count = 0; count < numin; count++)
            {
            if (diskbuf[count] == PROG_CRUNCHED)
               {
               if (numin-count < 4)  /* if not a full record */
                  {
                  if (numin < DISKBUF_SIZE)
                     flag = FALSE;
                  else
                     lseek(filein,(long)(count-numin),1);
                                       /* back to start of record */
                  break;
                  }
               memfill(seg,ofs,*(unsigned int *)&diskbuf[count+1],diskbuf[count+3]);
               ofs += *(unsigned int *)&diskbuf[count+1];
               seg += ofs/16;
               ofs %= 16;
               count += 3;  /* skip the record stuff */
               }
            else
               {
               POKE(diskbuf[count],seg,ofs);
               if (++ofs > 15)
                  {
                  seg += ofs/16;
                  ofs %= 16;
                  }
               }
            }
         }
      } while ((numin) && (flag));
   close(filein);
   memory_model = cgm_header.exe_model;
   reloc_ds = cgm_header.exe_data_seg;
   file_type = cgm_header.filetype_flag;
   load_offset =
   regs.r.ip = cgm_header.load_ofs;
   startloc = cgm_header.start_offset;
   return(TRUE);
   }

unsigned int crunch_it(seg,ofs)
   unsigned int seg;
   long *ofs;
   {
   long count, count3;
   unsigned int repeat_len, count2;
   unsigned char ch;

   count = *ofs;
   count2 = 0;
   while ((count <= 65535) && (count2 < DISKBUF_SIZE-4))  /* make sure we do not overflow buffer */
      {
      ch = PEEK(seg,(unsigned int)count);
      repeat_len = 1;  /* can count the 1st char as a repeat, too */
      for (count3 = count+1; (count3 < 65535) && (PEEK(seg,(unsigned int)count3) == ch);
                                                                  count3++)
         repeat_len++;
      if ((repeat_len > 4) || (ch == PROG_CRUNCHED))
         {
         diskbuf[count2++] = PROG_CRUNCHED;
         *(unsigned int *)&diskbuf[count2] = repeat_len;
         count2 += 2;
         count += repeat_len - 1;  /* -1 to offset the count++ below */
         }
      diskbuf[count2++] = ch;
      count++;
      };
   *ofs = count;
   return(count2);
   }

void write_map()
   {
   int count,i;
   unsigned int crunched_len, intnum_offset;
   long longofs;
   char tempstr[150];

   strcpy(tempstr,filename);
   for (count = 0; count < strlen(tempstr); count++)
      if (tempstr[count] == '.')
         tempstr[count] = '\0';
   strcat(tempstr,".CGM");
   cls();
   puts("Write MAP file:");
   while (1)
      {
      putsat(2,0,"Press Return for ");
      puts(tempstr);
      puts(",\nor enter the map filename? ");
      clear_to_bottom(3,26);
      if (mygets(globalstr) == -1)
         {
         putsat(5,0,esc_to_quit_msg);
         if (check_key() == ESC_KEY)
            return;
         continue;
         }
      if (globalstr[0])
         strcpy(tempstr,globalstr);
      if ((fileout = open(tempstr,MODE_READ)) != -1)
         {
         close(fileout);
         do
            {
            puts("\nThe map file already exists.\n");
            puts("Do you wish to overwrite it (Y, N, or Return to quit)? ");
            mygets(globalstr);
            if (globalstr[0] == '\0')
               return;
            globalstr[0] = toupper(globalstr[0]);
            } while ((globalstr[0] != 'Y') && (globalstr[0] != 'N'));
         if (globalstr[0] == 'N')
            continue;
         }
      fileout = creat(tempstr);
      strcpy(cgm_header.signature,cgm_signature);
      cgm_header.map_ofs = sizeof(struct cgmap_header) + 4;
      cgm_header.load_ofs = load_offset;
      cgm_header.load_seg = 0;  /* for future expansion */
      cgm_header.filetype_flag = file_type;
      cgm_header.exe_model = memory_model;
      cgm_header.exe_data_seg = reloc_ds;
      cgm_header.flagword = CGM_FLAG_PROCESSOR;  /* always save processor */
      intnum_offset = 0;
      if (num_ints_to_comment)
         {
         cgm_header.flagword |= CGM_FLAG_INTADDR;
         intnum_offset = 4 + sizeof(struct cgmap_header);
         cgm_header.map_ofs += 2 +  num_ints_to_comment * sizeof(struct int_offset);
         }
      cgm_header.start_offset = startloc;
      write(fileout,&cgm_header,sizeof(struct cgmap_header));
      write(fileout,&intnum_offset,2);
      write(fileout,&cpu_type,2);
      if (num_ints_to_comment)
         {
         lseek(fileout,(long)intnum_offset,0);
         write(fileout,&num_ints_to_comment,2);
         write(fileout,ints_to_comment,num_ints_to_comment * sizeof(struct int_offset));
         }
      longofs = 0;
      while (crunched_len = crunch_it(mapspace,&longofs))
         {
         write(fileout,diskbuf,crunched_len);
         }
      if ((file_type == TYPE_EXE) && (highseg != lowseg))
         {
         longofs = 0;
         while (crunched_len = crunch_it(mapspace+0x1000,&longofs))
            {
            write(fileout,diskbuf,crunched_len);
            }
         }
      close(fileout);
      return;
      }
   }

init_device_map()
   {
   int filein, numin;

   SETDFLAG(0,PROG_DATA | PROG_WORD);   /* start of ptr to next */
   SETDFLAG(2,PROG_WORD);               /* remainder of ptr to next */
   SETDFLAG(4,PROG_DATA | PROG_WORD);   /* attributes */
   SETDFLAG(6,PROG_ADDRESS|PROG_WORD);  /* strategy */
   SETDFLAG(8,PROG_ADDRESS|PROG_WORD);  /* interrupt */
   SETDFLAG(10,PROG_DATA);              /* device name */
   filein = open(filename,MODE_READ);
   numin = read(filein,diskbuf,10);
   close(filein);
   if (numin == 10)
      SETCFLAG(*(unsigned int *)&diskbuf[8],PROG_LABEL);
       /* mark interrupt routine, strategy routine will be passed to map_it */
   }

map_it(start_addr)
   {
   unsigned int done;
   unsigned int count;
   int decodeok, allok;
   char hexstr[20],*hexlong(),byte,ch2;

   REGS_UNKNOWN;  /* start off clean */
   cls();
   puts("Mapping program space");
   done = FALSE;
   regs.r.ip = start_addr;
   SETCFLAG(start_addr,PROG_LABEL);
   do
      {
      prefix = 0;  /* clear out prefixes */
      dest.where =
      source.where = MEM_REG_UNKNOWN; /* MEMORY; */
                                 /* default to UNKNOWN source/destination */
      startip = regs.r.ip;  /* local for location of all prefixes, no int */
      if ((byte = PEEK(codemap,startip)) & PROG_KNOWN)  /* if already passed through */
         find_new_thread(&done);
      else
         {
         if (byte & PROG_LABEL)
            REGS_UNKNOWN;
         do
            {
            decodeok = decode(hexstr,instr);
            } while ((instruction.flags & PREFIX) && (decodeok));
         allok = TRUE;
         if (decodeok) /* && (regs.r.ip >= progstart) && (regs.r.ip < progend)) */
            {
            allok = map_code(startip,regs.r.ip,&done);
            if (do_term_tracking)
               (*opfns[instruction.name])();  /* go do register tracking */
            }
         if ((!decodeok) || (!allok) || (regs.r.ip < progstart)
                                                  || (regs.r.ip >= progend))
            {
            if (!decodeok)
               {
               if (PEEK(codemap,startip) & PROG_LABEL)  /* if label on a undefined opcode */
                  _poke((PEEK(codemap,startip)&~PROG_LABEL)|PROG_OFFSET,startip,codemap);
                                       /* try it as a offset */
               _poke(PEEK(codemap,startip)&~(PROG_CODE|PROG_KNOWN),startip,codemap);
               }
            find_new_thread(&done);
            REGS_UNKNOWN;
            if (startip == regs.r.ip)  /* if we just found ourselves! */
               done = TRUE;
            }
         }
      } while (!done);
   }

int map_code(start,stop,done)
   unsigned int start;
   unsigned int stop;
   unsigned int *done;
   {
   unsigned int count, temp, i, retval;

   retval = TRUE;   /* did not hit program terminate */
   for (count = start; count < stop; count++)
      SETCFLAG(count,PROG_KNOWN | PROG_CODE);
   if ((source.where == MEMORY) && (((mod == 0) && (rm == 6))
                                     || (mod == 2)
                                     || (instruction.source == SADDR16)))
      {
      if (source.seg == regs.r.cs)
         {
         if (instruction.flags & BYTE)
            SETCFLAG(source.ofs,PROG_DATA);
         else
            SETCFLAG(source.ofs,PROG_DATA | PROG_WORD);
         }
      else
         {
         if (instruction.flags & BYTE)
            SETDFLAG(source.ofs,PROG_DATA);
         else
            SETDFLAG(source.ofs,PROG_DATA | PROG_WORD);
         }
      }
   if ((dest.where == MEMORY) && (((mod == 0) && (rm == 6))
                                     || (mod == 2)
                                     || (instruction.dest == DADDR16)))
      {
      if (dest.seg == regs.r.cs)
         {
         if (instruction.flags & BYTE)
            SETCFLAG(dest.ofs,PROG_DATA);
         else
            SETCFLAG(dest.ofs,PROG_DATA | PROG_WORD);
         }
      else
         {
         if (instruction.flags & BYTE)
            SETDFLAG(dest.ofs,PROG_DATA);
         else
            SETDFLAG(dest.ofs,PROG_DATA | PROG_WORD);
         }
      }
   if ((instruction.source == SDATA16) && ((unsigned int)source.value < 0xfffe)
           && (instruction.name != AND) && (instruction.name != OR)
           && (instruction.name != XOR) && (instruction.name != TEST))
      if (regs.r.ds == regs.r.cs)
         SETCFLAG((unsigned int)source.value,PROG_OFFSET);
      else
         SETDFLAG((unsigned int)source.value,PROG_OFFSET);
   switch (instruction.name)
      {
      case JA:
      case JAE:
      case JCXZ:
      case JGE:
      case JG:
      case JNA:
      case JNAE:
      case JNG:
      case JNGE:
      case JNO:
      case JNS:
      case JNZ:
      case JO:
      case JPE:
      case JPO:
      case JS:
      case JZ:
      case LOOP:
      case LOOPNZ:
      case LOOPZ:
         SETCFLAG((unsigned int)source.value,PROG_CODE | PROG_LABEL);
         break;
      case CALL:
         if (instruction.source != SM)
            SETCFLAG((unsigned int)source.value,PROG_CODE | PROG_LABEL);
         if (num_call_addrs)
            {
            for (i = 1; i <= num_call_addrs; i++)
               if ((unsigned int)source.value == noret_call_addrs[i].offset)
                  {
                  if (noret_call_addrs[i].endbyte_flag)
                     {
                     temp = regs.r.cs;
                     count = regs.r.ip;
                     checkaddress(&temp,&count);
                     if ((count = findbyte(temp,regs.r.ip,progend,noret_call_addrs[i].endbyte))
                                    != 0xffff)
                        regs.r.ip = count+1;  /* want byte after this */
                     else
                        find_new_thread(done);
                     break;
                     }
                  else
                     {
                     find_new_thread(done);
                     break;
                     }
                  }
            }
         break;
      case JMP:
         if (instruction.source != SM)
            SETCFLAG((unsigned int)source.value,PROG_CODE | PROG_LABEL);
         if (((instruction.source != SOFF16) && (instruction.source != SOFF8))
                || ((unsigned int)source.value < progstart)
                || ((unsigned int)source.value > progend)
                || (PEEK(codemap,(unsigned int)source.value) & PROG_KNOWN))
            find_new_thread(done);
         else
            regs.r.ip = (unsigned int)source.value;
         break;
      case CALLF:
      case JMPF:
         if (instruction.name == JMPF)
            find_new_thread(done);
         break;
      case IRET:
      case RET:
      case RETF:
         find_new_thread(done);
         break;
      case INT:
         if ((!do_term_tracking) || (instruction.flags & INT3))
            break;   /* no more */
         count = (unsigned int)source.value;  /* use count as a temp */
         if ((count == 0x20) || (count == 0x27))
            retval = FALSE;  /* program terminate */
         if ((count == 0x21) && (regsknown.byteknown[1])
                     && ((regvalues.r.ax.byte.ah == 0x00)
                            || (regvalues.r.ax.byte.ah == 0x31)
                            || (regvalues.r.ax.byte.ah == 0x4c)))
            retval = FALSE;  /* program terminate */
         break;
      }
   return(retval);
   }

char *hnumber(value,str,seg,fromseg,fromofs)
   unsigned int value, seg, fromseg, fromofs;
   char *str;
   {
   int index;

   if ((num_syms) && ((index = lookup_sym(seg,value)) != -1))
      strcpy(str,symbols[index].sym);
   else
      {
      if (file_type == TYPE_EXE)
         {
         if (seg == regs.r.cs)
            str[0] = 'C';
         else
            str[0] = 'D';
         }
      else
         str[0] = 'H';
      str[1] = '_';
      hexword(&value,&str[2]);
      }
   if ((do_xref) && ((fromseg != 0xffff) || (fromofs != 0xffff)))
      add_xref(seg,value,fromseg,fromofs);
   return(str);
   }

add_xref(seg,ofs,fromseg,fromofs)
   unsigned int seg, ofs, fromseg, fromofs;
   {
   long pos, file_size, bytestomove, fromloc, toloc;
   int numin;
   long min, max, middle;
   struct xref_index_struc *pi, new_index;
   struct xref_entry_struc new_entry;

   if ((skip_short_xref) && (seg == fromseg))
      {
      if (ofs > fromofs)
         {
         if (ofs-fromofs <= skip_short_xref_dist)
            return;
         }
      else
         {
         if (fromofs-ofs <= skip_short_xref_dist)
            return;
         }
      }
   file_size = lseek(xref_index,0L,2);  /* get size */
   pi = diskbuf;  /* address diskbuf via ptr to our structure */
   min =
   max =
   middle = 0;  /* at first, the null element */
   if (file_size)  /* if there are entries already */
      {
      max = (file_size / (long)sizeof(struct xref_index_struc)) - 1;
      do
         {
         middle = (min + max) >> 1;
         lseek(xref_index,middle * (long)sizeof(struct xref_index_struc),0);
         if (read(xref_index,diskbuf,sizeof(struct xref_index_struc))
                       != sizeof(struct xref_index_struc))
            return(xref_error());
         if ((pi->seg == seg) && (pi->ofs == ofs))  /* found entry, update list */
            {
            lseek(xref_file,pi->last,0);
            if (read(xref_file,&new_entry,sizeof(struct xref_entry_struc))
                             != sizeof(struct xref_entry_struc))
               return(xref_error());
            pos =
            new_entry.next = lseek(xref_file,0L,2);  /* get new pointer */
            lseek(xref_file,pi->last,0);
            if (write(xref_file,&new_entry,sizeof(struct xref_entry_struc))
                             != sizeof(struct xref_entry_struc))
               return(xref_error());
            pi->last = pos;  /* location of new entry */
            new_entry.seg = fromseg;
            new_entry.ofs = fromofs;
            new_entry.next = NULL;
            lseek(xref_file,0L,2);
            if (write(xref_file,&new_entry,sizeof(struct xref_entry_struc))
                             != sizeof(struct xref_entry_struc))
               return(xref_error());
            lseek(xref_index,middle * (long)sizeof(struct xref_index_struc),0);
            if (write(xref_index,diskbuf,sizeof(struct xref_index_struc))
                                   != sizeof(struct xref_index_struc))
               return(xref_error());
            return;  /* and done! */
            }
         if ((pi->seg > seg) || ((pi->seg == seg) && (pi->ofs > ofs)))
            max = middle - 1;
         else
            min = middle + 1;
         } while (min <= max);
      }
   pos = min * ((long)sizeof(struct xref_index_struc));
   fromloc =
   bytestomove = lseek(xref_index,0L,2);
   bytestomove -= pos;
   while (bytestomove)
      {
      numin = (bytestomove > INDEX_ENTRIES_BYTES) ?
                   INDEX_ENTRIES_BYTES : (int)bytestomove;
      fromloc -= numin;
      bytestomove -= numin;
      toloc = fromloc + sizeof(struct xref_index_struc);
      lseek(xref_index,fromloc,0);
      if (read(xref_index,diskbuf,numin) != numin)
         return(xref_error());
      lseek(xref_index,toloc,0);
      if (write(xref_index,diskbuf,numin) != numin)
         return(xref_error());
      }
   lseek(xref_index,pos,0);
   new_index.seg = seg;
   new_index.ofs = ofs;
   new_index.last =
   new_index.first = lseek(xref_file,0L,2);
   if (write(xref_index,&new_index,sizeof(struct xref_index_struc))
                    != sizeof(struct xref_index_struc))
      return(xref_error());
   new_entry.seg = fromseg;
   new_entry.ofs = fromofs;
   new_entry.next = NULL;
   if (write(xref_file,&new_entry,sizeof(struct xref_entry_struc))
                          != sizeof(struct xref_entry_struc))
      return(xref_error());
   }

xref_error()
   {
   do_xref = FALSE;  /* xref FALSE and files will signal error later */
   }

show_xref()
   {
   int i, count;
   struct xref_index_struc this_index;
   struct xref_entry_struc this_entry;

   skip_short_xref =
   do_xref = FALSE;  /* don't need these anymore! */
   myfputs(";\n; CROSS REFERENCE\n;\n");
   if (lseek(xref_index,0L,2) == 0L)  /* if no entries */
      {
      myfputs(";  NONE\n;\n");
      return;
      }
   lseek(xref_index,0L,0);
   do
      {
      if (read(xref_index,&this_index,sizeof(struct xref_index_struc))
                 != sizeof(struct xref_index_struc))
         break;
      lseek(xref_file,this_index.first,0);
      if (read(xref_file,&this_entry,sizeof(struct xref_entry_struc))
                  != sizeof(struct xref_entry_struc))
         break;
      myfputs(";  ");
      myfputs(hnumber(this_index.ofs,globalstr,this_index.seg,0xffff,0xffff));
      myfputs(" REFERENCED AT:\n;  ");
      count = 7;
      do
         {
         hnumber(this_entry.ofs,globalstr,this_entry.seg,0xffff,0xffff);
         if (count + (9-count%9) + strlen(globalstr) > 80)
            {
            myfputs("\n;  ");
            count = 7;
            }
         for (i = count % 9; i < 9; i++, count++)
            myfputs(" ");
         myfputs(globalstr);
         count += strlen(globalstr);
         if (this_entry.next == NULL)
            break;
         lseek(xref_file,this_entry.next,0);
         if (read(xref_file,&this_entry,sizeof(struct xref_entry_struc))
                  != sizeof(struct xref_entry_struc))
            break;
         } while (TRUE);  /* until a break */
      if (myfputsok == -1)  /* someone pushed the button! */
         break;
      myfputs("\n;\n");
      } while (TRUE);  /* until a break */
   }

char *numberh_word(value,str)
   unsigned int value;
   char *str;
   {
   str[0] = '0';
   if (value > 0x9fff)
      {
      hexword(&value,&str[1]);
      str[5] = 'H';
      str[6] = '\0';
      }
   else
      {
      hexword(&value,str);
      str[4] = 'H';
      str[5] = '\0';
      }
   return(str);
   }

char *numberh_byte(value,str)
   unsigned int value;
   char *str;
   {
   str[0] = '0';
   if (value > 0x9f)
      {
      hexbyte(&value,&str[1]);
      str[3] = 'H';
      str[4] = '\0';
      }
   else
      {
      hexbyte(&value,str);
      str[2] = 'H';
      str[3] = '\0';
      }
   return(str);
   }

void find_new_thread(done)
   unsigned int *done;
   {
#ifdef NEVERDEF
         /* NOTE:  This C code does the job, but it is slow.  The inline
                   assembler below does the job much faster. */
   unsigned int count,byte;

   puts(".");
   *done = TRUE;
   for (count = progstart; count < progend; count++)
      {
      byte = PEEK(codemap,count);
      if ((byte & PROG_LABEL) && (!(byte & PROG_KNOWN)))
         {
         *done = FALSE;
         regs.r.ip = count;
         break;
         }
      }
#endif

   puts(".");  /* keep this in C */
   *done = TRUE;  /* this, too */
#asm
   mov si,word progstart_    ;get starting address
   dec si                    ;-1 for loop start
   mov ax,word codemap_      ;get codespace segment
   mov es,ax                 ;use ES to address it
f_n_t_1:
   inc si                    ;pointer+1
   cmp si,word progend_      ;done?
   jae f_n_t_2               ;yes, quit
   mov al,byte es:[si]       ;get map byte
   and al,84h                ;get prog_label (4) and prog_known (0x80) bits
   cmp al,4                  ;label only?
   jne f_n_t_1               ;no, skip this
   mov bx,word [bp+4]        ;get pointer
   mov word [bx],0           ;*done = FALSE
   mov word regs_[26],si     ;regs.r.ip = count
f_n_t_2:
#endasm
   }

unsigned int isastring(count,whichmap,whichseg,maxcount)
   unsigned int count, whichmap, whichseg, maxcount;
   {
   unsigned int pos, start;
   unsigned char ch, ch2;

   pos = 0;
   start = count;
   if (isstrchr(ch=fetchbyte(whichseg,count++),FALSE))
      {
      while ( ((!use_term_char) || (ch != term_char)) && (PEEK(whichmap,count) == PROG_UNKNOWN) && (count < maxcount)
                          && (isstrchr(ch=fetchbyte(whichseg,count++),use_term_char)))
         pos = count;
      }
   if (count - start < 5)
      pos = 0;
   return(pos);
   }

int isstrchr(ch,use_term)
   unsigned char ch;
   unsigned int use_term;
   {
   if ( ((ch >= ' ') && (ch < '\177')) || (ch == '\015') || (ch == '\012')
                        || (ch == '\010') || (ch == '\011')
                        || ((use_term) && (ch == term_char)) )
      return(TRUE);
   return(FALSE);
   }

int isaprint(ch)
   unsigned char ch;
   {
   if ((ch >= ' ') && (ch < '\177'))
      return(TRUE);
   return(FALSE);
   }

int showbyte(ch)
   unsigned char ch;
   {
   return( ((ch >= ' ') && (ch <= '~')) ? ch : '.');
   }

unsigned int fromqueue()  /* Fetch the next program byte.  This is called
                             from decode() and decodens() instead of
                             fetchbyte() as it is faster, as no parameters
                             are passed, and the segment and offset are
                             known */
   {
   unsigned int seg,ofs;

   seg = regs.r.cs;  /* make copies that we can change */
   ofs = regs.r.ip++;  /* remember to update IP */
   checkaddress(&seg,&ofs);  /* Translate to real address.  Note that
        the proper byte is returned, even if this is a protected address. */
/*   return (unsigned int)PEEK(seg,ofs);  and get the byte */
#asm
   les bx,word [bp-4]
   xor ax,ax
   mov al,byte es:[bx]
#endasm
   }

unsigned int fetchbyte(seg,ofs)  /* fetch a byte from virtual memory */
   unsigned int seg,ofs;
   {
   checkaddress(&seg,&ofs);  /* Translate to real address.  Note that
        the proper byte is returned, even if this is a protected address. */
/*   return (unsigned int)PEEK(seg,ofs);  and get the byte */
#asm
   mov es,word [bp+4]
   mov bx,word [bp+6]
   xor ax,ax
   mov al,byte es:[bx]
#endasm
   }

unsigned int fetchword(seg1,ofs1)  /* as above, but for words */
   unsigned int seg1,ofs1;
   {
   unsigned int seg2,ofs2;

   seg2 = seg1;
   ofs2 = ofs1 + 1;
   checkaddress(&seg1,&ofs1);
   checkaddress(&seg2,&ofs2);
/*   return( PEEK(seg,ofs) + (PEEK(seg,ofs+1) << 8) ); */
#asm
   mov es,word [bp+4]
   mov bx,word [bp+6]
;   mov ax,word es:[bx]
   mov al,byte es:[bx]
   les bx,word [bp-4]
   mov ah,byte es:[bx]
#endasm
   }

char *strupr(str)
   char *str;
   {
   int i;

   i = -1;
   while (str[++i])
      str[i] = toupper(str[i]);
   return(str);
   }

char *strlwr(str)
   char *str;
   {
   int i;

   i = -1;
   while (str[++i])
      str[i] = tolower(str[i]);
   return(str);
   }

unsigned int peekw(seg,ofs)  /* peek a WORD address */
   unsigned int seg,ofs;
   {
   return( PEEK(seg,ofs) + (PEEK(seg,ofs+1) << 8) );
   }

memfill(seg,offset,len,byte)
     /* +4  +6     +8  +10 */
   {
#asm
   mov es,word [bp+4]
   mov di,word [bp+6]
   mov cx,word [bp+8]
   mov al,byte [bp+10]
   cld                 ;up!
   db 0f3h             ;REP
   stosb               ;fill with byte
#endasm
   }

void cls()
   {
#asm
   mov cx,0     ;row,col of upper left corner
   mov dx,184fh ;row,col of lower right corner
   mov bh,7     ;fill attribute
   mov ax,600h  ;scroll up entire window
   push bp      ;save bp
   int 10h      ;call BIOS
   pop bp       ;restore bp
   mov dx,0     ;row 0, col 0
   mov bh,0     ;page 0
   mov ah,2     ;set cursor position
   push bp      ;save bp
   int 10h      ;call BIOS
   pop bp       ;restore bp
#endasm
   }

clear_to_bottom(r,c)
   {
#asm
   mov ch,byte [bp+4]   ;upper left row
   mov cl,byte [bp+6]   ;upper left col
   mov dh,ch            ;lower right row
   mov dl,79            ;lower right col
   mov bh,7             ;fill attribute
   mov ax,600h          ;scroll up and erase
   push cx              ;save upper left corner
   push bp              ;save bp
   int 10h              ;call BIOS
   pop bp               ;restore bp
   pop cx               ;restore upper left corner
   cmp ch,18h           ;already at end?
   je end_of_clear_to_bottom  ;yes, we're done
   inc ch               ;next row
   xor cl,cl            ;start at col 0
   mov dx,184fh         ;lower right is row 24, col 79
   mov bh,7             ;fill attribute
   mov ax,600h          ;scroll up entire region
   push bp              ;save BP
   int 10h              ;call BIOS
   pop bp               ;restore BP
end_of_clear_to_bottom:
#endasm
   }

void curpos(row,col)
   int row,col;
   {
#asm
   mov dh,byte [bp+4]  ;row
   mov dl,byte [bp+6]  ;col
   mov bh,0            ;page
   mov ah,2            ;set cursor position
   push bp             ;save bp
   int 10h             ;call BIOS
   pop bp              ;restore bp
#endasm
   }

gchar()
   {
#asm
   mov dl,0ffh
   mov ah,6
   int 21h
   jz  gchar1
   mov ah,0
   jmp gchar2
gchar1: mov ah,1
gchar2:
#endasm
   }

void itoa(number,str)    /* write what should be a library routine */
   int number;
   char *str;
   {
   char buffer[7], *ptr;

   buffer[6] = '\0';
   ptr = &buffer[5];
   do
      {
      *(ptr--) = number  % 10 + '0';
      } while ((number /= 10) > 0);
   ptr++;
   strcpy(str, ptr);
   }

int pressany(flag)
   int flag;
   {
   puts("\nPress any key to continue");
   if (flag)
      puts(", or Esc to quit");
   return(check_key());
   }

int check_key()
   {
   int retval;

   if ((retval = ci()) == '\0')
      retval = ci();
   return(retval);
   }

char *itox(val,str)
   unsigned int val;
   unsigned char *str;
   {
   int i;

   str += 4;
   for (i = 0; i < 4; i++)
      {
      *(--str) = (val & 0x0f) + (((val & 0x0f) > 9) ? 'A'-10 : '0');
      val >>= 4;
      }
   str[4] = '\0';
   return(str);
   }

void putsat(r,c,s)
   int r,c;
   char *s;
   {
   curpos(r,c);
   puts(s);
   }

int char_in_str(ch,str)
   unsigned char ch;
   unsigned char *str;
   {
   int i;

   i = 0;
   while (str[i])
      {
      if (str[i] == ch)
         return(i);
      i++;
      }
   return(-1);
   }

get_curpos(row,col)
   int *row, *col;
   {
#asm
   mov bh,0           ;page 0
   mov ah,3           ;fn = get cursor position
   push bp            ;keep BP safe from BIOS
   int 10h            ;call video BIOS
   pop bp             ;restore bp
   xor ax,ax          ;ax = 0
   mov al,dh          ;ax = row position of cursor
   mov bx,word [bp+4] ;get addr of ROW
   mov word [bx],ax   ;set row
   mov al,dl          ;ax = col position of curosr
   mov bx,word [bp+6] ;get addr of COL
   mov word [bx],ax   ;set col
#endasm
   }

int mygets(str)
   char *str;
   {
   int len,ch,row,col,col2,temp,temp2;

   get_curpos(&row,&col);  /* get cursor row */
   len = 0;
   while (1)             /* forever */
      {
      do
         {
         while ((ch = gchar()) > 255)
            ;                  /* wait for keypress */
         if (!ch)              /* if null (1st char of extended keypress) */
            while (gchar() > 255)
               ;
         } while (!ch);
      if (ch == ESC_KEY)
         {
         str[0] = '\0';
         if (row < 24)
            puts(nl_str);
         return(-1);
         }
      if (ch == '\010')
         {
         if (len)
            {
            len--;
            if (str[len] == '\t')
               {
               temp2 = col;
               for (temp = 0; temp < len; temp++)
                  temp2 += (str[temp] == '\t') ? (8-temp2%8) : 1;
               get_curpos(&temp,&col2);
               for ( ; temp2 < col2; temp2++)
                  puts("\010");
               }
            else
               puts("\010 \010");
            }
         }
      else
         if (ch == '\015')
            {
            str[len] = '\0';
            if (row < 24)
               puts(nl_str);
            return(len);
            }
         else
            {
            get_curpos(&temp,&col2);
            temp = col2 + 8 - col2 % 8;
            if (ch == '\t')
               {
               if (temp > 78)
                  putchar('\007');
               else
                  {
                  str[len++] = ch;
                  onechar[0] = ' ';
                  for (temp -= col2; temp; temp--)
                     puts(onechar);
                  }
               }
            else
               if ((len < 70) && (col2+1 < 78))
                  {
                  if ((ch >= 32) && (ch < 128))
                     {
                     str[len++] = ch;
                     onechar[0] = ch;
                     puts(onechar);
                     }
                  }
               else
                  putchar('\007');
            }
      }
   }

int get_answer(row,col,continue_flag,prompt,esc_msg,str)
   int row,col,continue_flag;
   char *prompt,*esc_msg,*str;
   {
   int mygetsval, clear_col;

   clear_col = col + strlen(prompt);
   do
      {
      putsat(row,col,prompt);
      if ((mygetsval = mygets(str)) == -1)
         {
         clear_to_bottom(row,clear_col);
         putsat(row+2,0,esc_msg);
         if (check_key() == ESC_KEY)
            return(-1);  /* report user is aborting */
         clear_to_bottom(row,clear_col);
         if (continue_flag)
            return(-2);  /* let caller handle next iteration */
         }
      } while (mygetsval == -1);
   return(0);  /* non-negative */
   }

set_noret_call_addrs()
   {
   unsigned int i, j, temp, callofs;
   unsigned char answer, ch2;

   do
      {
      cls();
      puts("Set addresses for CALL's that do not return to the next statement.");
      if (num_call_addrs)
         {
         putsat(2,0,"Current addresses:\n");
         for (i = 1; i <= num_call_addrs; i++)
            {
            puts("CS:");
            puts(hexword(&noret_call_addrs[i].offset,globalstr));
            if (noret_call_addrs[i].endbyte_flag)
               {
               puts("=");
               puts(hexbyte(&noret_call_addrs[i].endbyte,globalstr));
               }
            else
               puts("   ");
            puts("    ");
            if (i % 4 == 0)
               puts(nl_str);
            }
         if (num_call_addrs == NUM_NORET_CALL_ADDRS)
            putsat(7,0,"Table is full.");
         }
      putsat(9,2,"A: Add an address\n");
      puts("  D: Delete an address\n\n");
      puts("  R: Return to the main menu (Default if Return is pressed)\n");
      do
         {
         curpos(14,0);
         puts(ask_option);
         clear_to_bottom(14,8);
         mygets(globalstr);
         answer = toupper(globalstr[0]);
         if (answer == '\0')
            answer = 'R';
         } while (char_in_str(answer,"ADR") == -1);
      if (answer != 'R')
         {
         putsat(16,0,"What is the address (offset only)? ");
         if (mygets(globalstr) != -1)
            {
            if ((!globalstr[0]) || ((temp = numval(globalstr,&callofs)) == FALSE))
               {
               putsat(18,0,ill_addr_msg);
               pressany(FALSE);
               }
            else
               {
               for (i = 1; i <= num_call_addrs; i++)
                  if (noret_call_addrs[i].offset == callofs)
                     {
                     num_call_addrs--;
                     for (j = i; j <= num_call_addrs; j++)
                        noret_call_addrs[j] = noret_call_addrs[j+1];
                     }
               if ((answer == 'A') && (num_call_addrs != NUM_NORET_CALL_ADDRS))
                  {
                  noret_call_addrs[++num_call_addrs].offset = callofs;
                  noret_call_addrs[num_call_addrs].endbyte_flag = FALSE;
                  putsat(18,0,"Do you want a terminating byte (Y/N)? ");
                  mygets(globalstr);
                  if (toupper(globalstr[0]) == 'Y')
                     {
                     putsat(20,0,"What is the terminal byte (in hex)? ");
                     if (mygets(globalstr) != -1)
                        {
                        if ((!globalstr[0]) || ((temp = numval(globalstr,&callofs)) == FALSE))
                           {
                           putsat(22,0,ill_addr_msg);
                           pressany(FALSE);
                           }
                        else
                           {
                           noret_call_addrs[num_call_addrs].endbyte_flag = TRUE;
                           noret_call_addrs[num_call_addrs].endbyte = callofs;
                           }
                        }
                     }
                  }
               }
            }
         }
      } while (answer != 'R');
   }

symbol_menu()
   {
   int i;
   unsigned int hold1, hold2, ptr, temp;
   char answer, ch2;  /* ch2 to keep stack aligned */
   int compare_sym_addr();  /* for ptr to function */

   do
      {
      cls();
      puts("Symbol table options:  ");
      itoa(num_syms,globalstr);
      puts(globalstr);
      puts(num_sym_msg);
      if (num_syms == SYM_TABLE_SIZE)
         puts(sym_tab_full_msg);
      if (num_syms == 0)
         puts(sym_tab_empty_msg);
      puts("\n\nDo you want to:\n\n");
      puts("  L: LOAD symbol table\n");
      puts("  S: SAVE symbol table\n\n");
      puts("  E: ENTER symbols\n");
      puts("  D: DELETE symbols\n\n");
      puts("  B: BROWSE symbols\n\n");
      puts("  R: Return to the main menu (Default if Return is pressed)\n");
      do
         {
         curpos(14,0);
         puts(ask_option);
         clear_to_bottom(14,8);
         mygets(globalstr);
         answer = toupper(globalstr[0]);
         if (answer == '\0')
            answer = 'R';
         } while (char_in_str(answer,"LSEDBR") == -1);
      switch (answer)
         {
         case 'L':
            cls();
            puts("Load Symbol Table:\n\n");
            do
               {
               byte = 'N';  /* default to failure */
               strcpy(outfile,filename);
               for (count = 0; count < strlen(outfile); count++)
                  if (outfile[count] == '.')
                     outfile[count] = '\0';
               strcat(outfile,".SYM");
               clear_to_bottom(2,0);
               putsat(2,0,"Press Return for ");
               puts(outfile);
               puts(",\nor enter the symbol filename? ");
               if (mygets(globalstr) == -1)
                  {
                  clear_to_bottom(3,29);
                  putsat(5,0,esc_to_quit_msg);
                  if (check_key() == ESC_KEY)
                     {
                     i = -1;
                     break;
                     }
                  clear_to_bottom(3,29);
                  byte = 'Y';  /* keep going */
                  continue;
                  }
               strupr(globalstr);
               if (globalstr[0])
                  strcpy(outfile,globalstr);
               byte = 'N';
               if ((i = open(outfile,MODE_READ)) == -1)
                  {
                  puts("\nThe file ");
                  puts(outfile);
                  puts(" does not exist.\nDo you wish to try another name (Y, N, or Return to quit)? ");
                  do
                     {
                     curpos(6,59);
                     mygets(globalstr);
                     if (globalstr[0] == '\0')
                        globalstr[0] = 'N';
                     byte = toupper(globalstr[0]);
                     if ((byte != 'Y') && (byte != 'N'))
                        {
                        clear_to_bottom(6,59);
                        puts(ill_resp_msg);
                        }
                     else
                        clear_to_bottom(8,0);
                     } while ((byte != 'Y') && (byte != 'N'));
                  }
               else
                  close(i);
               } while (byte == 'Y');
            if (i != -1)
               read_symbol_file();
            break;
         case 'E':
            cls();
            puts("Enter symbols:\n\n");
            if (num_syms == SYM_TABLE_SIZE)
               {
               puts(sym_tab_full_msg);
               pressany(FALSE);
               }
            else
               {
               puts("Please enter the symbols in the format\n   offset symbol\n");
               puts("      or\n   segment:offset symbol\n");
               puts("where segment is CS, DS, ES, SS, or a hex number, offset is a hex number,\n");
               puts("and symbol is an ascii string.  The default segment is DS.\nEnter a blank line to quit.\n\n");
               while (num_syms < SYM_TABLE_SIZE)
                  {
                  puts("enter symbol? ");
                  mygets(globalstr);
                  if (!globalstr[0])
                     break;
                  if ((temp = parse_symbol(TRUE)) == FALSE)
                     puts(ill_sym_msg);
                  else
                     if (temp == TRUE)
                        qsort(symbols,num_syms,sizeof(struct symbol_table),compare_sym_addr);
                  }
               }
            break;
         case 'D':
            cls();
            puts("Delete symbols:\n\n");
            if (!num_syms)
               {
               puts(sym_tab_empty_msg);
               pressany(FALSE);
               }
            else
               {
               puts(sym_addr_instr1);
               puts(sym_addr_instr2);
               puts(sym_addr_instr3);
               puts(sym_addr_instr4);
               while (num_syms)
                  {
                  puts(enter_sym_addr_msg);
                  mygets(globalstr);
                  if (!globalstr[0])
                     break;
                  ptr = 0;
                  parse_seg = regs.r.ds;
                  if ((parse_seg_and_ofs(&hold1,&hold2,&ptr,globalstr))
                         && ((i = lookup_sym(hold1,hold2)) != -1))
                     {
                     puts(hexword(&hold1,globalstr));
                     puts(":");
                     puts(hexword(&hold2,globalstr));
                     onechar[0] = ' ';
                     puts(onechar);
                     puts(symbols[i].sym);
                     puts("\nDelete this symbol? ");
                     mygets(globalstr);
                     if (toupper(globalstr[0]) == 'Y')
                        {
                        num_syms--;  /* remove this symbol */
                        if (i != num_syms)  /* if not the last symbol */
                           _move((num_syms-i)*sizeof(struct symbol_table),&symbols[i+1],&symbols[i]);
                        puts("symbol deleted.\n");
                        }
                     }
                  else
                     puts(ill_sym_msg);
                  }
               }
            break;
         case 'B':
            if (!num_syms)
               {
               puts(sym_tab_empty_msg);
               pressany(FALSE);
               }
            else
               browse_symbols();
            break;
         case 'S':
            save_symbols();
            break;
         }
      } while (answer != 'R');
   }

void browse_symbols()
   {
   int i;
   unsigned int hold1, hold2, ptr, temp, ofs2;
   char answer, ch2;  /* ch2 to keep stack aligned */
   struct symbol_table s;

   do
      {
      cls();
      puts("Browse symbol options:\n\nDo you want to:\n\n");
      puts("  D: DISPLAY all symbols (Esc to quit)\n");
      puts("  A: show symbols by ADDRESS\n");
      puts("  N: show symbols by NAME\n\n");
      puts("  R: Return to the symbol menu (Default if Return is pressed)\n");
      do
         {
         curpos(10,0);
         puts(ask_option);
         clear_to_bottom(10,8);
         mygets(globalstr);
         answer = toupper(globalstr[0]);
         if (answer == '\0')
            answer = 'R';
         } while (char_in_str(answer,"DANR") == -1);
      switch (answer)
         {
         case 'A':
            onechar[0] = ' ';
            cls();
            do
               {
               putsat(0,0,"Show symbols by Address:\n\n");
               puts(sym_addr_instr1);
               puts(sym_addr_instr2);
               puts(sym_addr_instr3);
               puts(sym_addr_instr4);
               puts(enter_sym_addr_msg);
               mygets(globalstr);
               if (globalstr[0])
                  {
                  ptr = 0;
                  parse_seg = regs.r.ds;
                  if (parse_seg_and_ofs(&hold1,&hold2,&ptr,globalstr))
                     {
                     clear_to_bottom(11,0);
                     do
                        {
                        ofs2 = hold2;
                        temp = TRUE;
                        putsat(11,0,ending_ofs_msg);
                        mygets(globalstr);
                        if ((globalstr[0]) && ((temp = numval(globalstr,&ofs2)) == FALSE))
                           {
                           clear_to_bottom(11,70);
                           putsat(13,0,ill_addr_msg);
                           }
                        } while (!temp);
                     globalstr[0] = 'a';  /* so will not fall through end check */
                     clear_to_bottom(13,0);
                     i = 0;
                     temp = FALSE;   /* no symbols shown */
                     while ((i < num_syms)
                           && ((symbols[i].seg != hold1) || (symbols[i].ofs < hold2)))
                        i++;
                     while ((i < num_syms) && (symbols[i].seg == hold1)
                                         && (symbols[i].ofs <= ofs2)
                                         && (gchar() != '\033'))
                        {
                        temp = TRUE;  /* symbol has been shown */
                        show_symbol(i++);
                        }
                     if (!temp)
                        puts(no_match_sym_msg);
                     pressany(FALSE);
                     cls();
                     }
                  else
                     {
                     clear_to_bottom(10,22);
                     putsat(12,0,ill_addr_msg);
                     }
                  }
               } while (globalstr[0]);
            break;
         case 'N':
            onechar[0] = ' ';
            do
               {
               cls();
               puts("Show symbols by Name:\n\nPress Return for the name to quit.\n\n");
               puts("Enter the symbol name (case is not important)? ");
               mygets(globalstr);
               if (globalstr[0])
                  {
                  strupr(globalstr);
                  hold1 = FALSE;  /* no symbols shown */
                  hold2 = strlen(globalstr);  /* length of compare */
                  for (i = 0; (i < num_syms) && (gchar() != '\033'); i++)
                     {
                     strcpy(prefix_str,symbols[i].sym);  /* use a temp string */
                     strupr(prefix_str);
                     if (strncmp(globalstr,prefix_str,hold2) == 0)
                        {
                        hold1 = TRUE;  /* a symbol has been shown! */
                        show_symbol(i);
                        }
                     }
                  if (!hold1)
                     puts(no_match_sym_msg);
                  pressany(FALSE);
                  }
               } while (globalstr[0]);
            break;
         case 'D':
            cls();
            for (i = 0; (i < num_syms) && (gchar() != '\033'); i++)
               show_symbol(i);
            pressany(FALSE);
            break;
         }
      } while (answer != 'R');
   }

show_symbol(i)
   int i;
   {
   char temp[10];

   onechar[0] = ' ';
   itox(symbols[i].seg,temp);
   temp[4] = ':';
   itox(symbols[i].ofs,&temp[5]);
   puts(temp);
   puts(onechar);
   puts(symbols[i].sym);
   puts(nl_str);
   }

int findbyte(seg,ofs,endofs,byte)
   {
#asm
   mov es,word [bp+4]          ;get search seg
   mov di,word [bp+6]          ;get search ofs
   mov cx,word [bp+8]          ;get ending ofs
   sub cx,di                   ;cx is search length
   mov al,byte [bp+10]         ;get search byte
   cld                         ;up!
   db 0f2h                     ;REPNE
   scasb                       ;find search byte
   mov ax,di                   ;get byte after
   je findbyte_found           ;found, return address
   xor ax,ax                   ;else set a 0
findbyte_found:
   dec ax                      ;back one to byte or 0xffff
#endasm
   }

unsigned int atox(str)
   char *str;
   {
   unsigned int val;

   val = 0;
   while (*str)
      {
      val <<= 4;
      val += (toupper(*str) > '9') ? *str - 'A' + 10 : *str - '0';
      str++;
      }
   return(val);
   }

int create_unique(str)
   char *str;
   {
   int i, val, filein;

   val = 0;
   for (i = 0; (str[i]) && (str[i] != '.'); i++)
      ;
   if (str[i] == '.')
      {
      i++;
      val = atox(&str[i]);
      }
   do
      {
      if ((filein = open(str,MODE_READ)) == ERR)
         return(creat(str));
      close(filein);
      val++;
      hexbyte(&val,&str[i]);
      } while (val < 0xff);
   return(ERR);  /* couldn't create unique file */
   }

set_processor_level(level)  /* 0 = 8086, 1 = 80186, 2 = 80286 */
   {
   int i;

   if (level)  /* 186/286 */
      {
      for (i = 0x60; i < 0x70; i++)
         firstbyte[i] = extended_186_instrs[i-0x60];  /* structure assignment */
      firstbyte[0xc0] = extended_186_instrs[16];
      firstbyte[0xc1] = extended_186_instrs[17];
      firstbyte[0xc8] = extended_186_instrs[18];
      firstbyte[0xc9] = extended_186_instrs[19];
      secondbyte[DD-DA][6] = extended_shl_instr;
      secondbyte[DE-DA][6] = extended_shl_instr;
      secondbyte[DF-DA][6] = extended_shl_instr;
      secondbyte[DG-DA][6] = extended_shl_instr;
      if (level == 2)  /* if 286 */
         firstbyte[0x0f] = extended_firstbyte_0f;
      else
         {
         firstbyte[0x0f] = undef_instr;  /* let's get rid of POP CS */
         firstbyte[0x63] = undef_instr;  /* and ARPL */
         }
      }
   else
      {
      for (i = 0x60; i < 0x70; i++)
         firstbyte[i] = undef_instr;  /* structure assignment */
      firstbyte[0xc0] = undef_instr;
      firstbyte[0xc1] = undef_instr;
      firstbyte[0xc8] = undef_instr;
      firstbyte[0xc9] = undef_instr;
      secondbyte[DD-DA][6] = undef_instr;
      secondbyte[DE-DA][6] = undef_instr;
      secondbyte[DF-DA][6] = undef_instr;
      secondbyte[DG-DA][6] = undef_instr;
      firstbyte[0x0f] = normal_firstbyte_0f;
      }
   }

map_jump_table()
   {
   unsigned int temp,i,dataseg,datastart,dataend,best_guess;
   unsigned int seg,ofs,whichmap,skipbytes;

   do
      {
      best_guess = FALSE;
      cls();
      puts("Map a JUMP/CALL table:\n\nThe default segment is CS.\n");
      puts("Enter a blank for the starting address to quit.");
      do
         {
         parse_seg = regs.r.cs;
         putsat(5,0,"What is the starting address (in hex, use SEG:OFS if needed)? ");
         mygets(globalstr);
         if ((globalstr[0])
                && ((temp = parse_seg_and_ofs(&dataseg,&datastart,&i,globalstr)) == FALSE))
            {
            clear_to_bottom(5,62);
            putsat(7,0,ill_addr_msg);
            }
         } while ((globalstr[0]) && (temp == FALSE));
      if (globalstr[0])
         {
         do
            {
            putsat(7,0,"What is the ending offset (in hex), or blank to have Codegen make a\n");
            puts("\'best guess\'? ");
            mygets(globalstr);
            if (!globalstr[0])
               {
               dataend = datastart;
               best_guess = TRUE;
               }
            else
               if ((temp = numval(globalstr,&dataend)) == FALSE)
                  {
                  clear_to_bottom(8,15);
                  putsat(10,0,ill_addr_msg);
                  }
            } while ((!best_guess) && (!temp));
         do
            {
            skipbytes = 0;
            putsat(10,0,"Enter the number of bytes to skip between table entries,\n");
            puts("or Return for none? ");
            mygets(globalstr);
            if ((globalstr[0]) && ((temp = numval(globalstr,&skipbytes)) == FALSE))
               {
               clear_to_bottom(11,20);
               putsat(13,0,"Illegal value");
               }
            } while ((globalstr[0]) && (!temp));
         globalstr[0] = TRUE;  /* so that we do not fall out of loop */
         clear_to_bottom(13,0);
         whichmap = (dataseg == regs.r.cs) ? codemap : datamap;
         if (datastart <= dataend)
            {
            while (1)  /* until I'm satisified */
               {
               temp = fetchword(dataseg,datastart);  /* get address word */
               if (whichmap == codemap)
                  SETCFLAG(datastart,PROG_ADDRESS|PROG_WORD);
               else
                  SETDFLAG(datastart,PROG_ADDRESS|PROG_WORD);
               map_it(temp);
               datastart += 2 + skipbytes;
               if (best_guess)
                  {
                  if (((PEEK(whichmap,datastart-1)&use_offset_mask) != PROG_UNKNOWN)
                        || ((PEEK(whichmap,datastart)&use_offset_mask) != PROG_UNKNOWN))
                     break;  /* that's all! */
                  }
               else
                  {
                  if (datastart > dataend)
                     break;
                  }
               }
            }
         else
            {
            puts("The ending address must be equal to or larger than the starting address,\n");
            puts("and both must be within in limits of the program.\n");
            pressany(FALSE);
            clear_to_bottom(5,0);
            }
         }
      } while (globalstr[0]);
   }

int compare_sym_addr(first,second)
   struct symbol_table *first, *second;
   {
   unsigned int retval;

   if (first->seg != second->seg)
      return(first->seg > second->seg ? 1 : -1);
   if (first->ofs != second->ofs)
      return(first->ofs > second->ofs ? 1 : -1);
   return(0);
   }

int parse_symbol(flag)  /* string to parse passed in globalstr */
   int flag;
   {
   unsigned int hold1, hold2, ptr, i, temp;
   unsigned char ch,byte;

   ptr = 0;
   parse_seg = regs.r.ds;
   if ((parse_seg_and_ofs(&hold1,&hold2,&ptr,globalstr)) && (globalstr[ptr-1] == ' '))
      {
      for (i = 0; i < 31; i++)
         {
         ch = globalstr[ptr+i];
         if ((!ch) || (ch == '\015') || (ch == '\012'))
            break;
         }
      if (i)
         {
         globalstr[ptr+i] = '\0';  /* terminate at CR or 31 chars */
         if ((flag) && ((temp = lookup_sym(hold1,hold2)) != -1))
            {
            puts("\nDo you wish to over-write the symbol ");
            show_symbol(temp);
            puts("(Y/N, Return = No)? ");
            mygets(instr);    /* use as a temporary string */
            if (toupper(instr[0]) != 'Y')
               return(-1);    /* say user abort */
            strcpy(symbols[temp].sym,&globalstr[ptr]);
            return(2);    /* say replacement */
            }
         symbols[num_syms].ofs = hold2;
         symbols[num_syms].seg = hold1;
         strcpy(symbols[num_syms++].sym,&globalstr[ptr]);
         return(TRUE);
         }
      }
   return(FALSE);
   }

parse_seg_and_ofs(seg,ofs,p,str)
   unsigned int *seg, *ofs, *p;
   unsigned char *str;
   {
   unsigned char temp[150];
   unsigned int i,ptr,hold1,hold2,flag,count;
   unsigned char ch,byte;

   ptr =
   i = 0;
   do
      {
      ch =
      temp[i] = str[ptr];
      i++;
      ptr++;
      } while ((ch) && (ch != ' ') && (ch != ':'));
   if (i < 6)  /* if this could be a valid symbol */
      {
      hold1 = parse_seg;  /* get our chosen segment */
      temp[i-1] = '\0';  /* back to the terminating char */
      if (ch == ':')  /* if a segment */
         {
         strupr(temp);
         flag = FALSE;
         for (count = 8; count < 12; count++)
            if (strcmp(temp,regnames[count]) == 0)
               {
               flag = TRUE;
               hold1 = regs.wordarray[count];
               }
         if (!flag)
            if ((numval(temp,&hold1) == FALSE)
                   || ((hold1 != regs.r.cs) && (hold1 != regs.r.ss)))
               return(FALSE);  /* this is no good */
         i = 0;
         do
            {
            ch =
            temp[i] = str[ptr];
            i++;
            ptr++;
            } while ((ch) && (ch != ' '));
         temp[i-1] = '\0';  /* back to the terminating char */
         if (i > 5)
            {
            return(FALSE);
            }
         }
      if (numval(temp,&hold2))
         {
         *ofs = hold2;
         *seg = hold1;
         *p = ptr;  /* say how far we got */
         return(TRUE);  /* and this is a good parse */
         }
      }
   return(FALSE);
   }

read_symbol_file()
   {
   char temp[10];
   int filein;
   unsigned int skipped;
   unsigned char ch,byte;

   filein = fopen(outfile,"r");  /* we could open it before, so... */
   skipped =
   num_syms = 0;  /* start off clean */
   while ((num_syms < SYM_TABLE_SIZE) && (fgets(globalstr,148,filein)))
      {
      if (!parse_symbol(FALSE))
         {
         if (!skipped)
            puts("\nInvalid symbols:\n\n");
         puts(globalstr);
         skipped++;
         }
      }
   fclose(filein);
   if (skipped)
      {
      itoa(skipped,temp);
      puts(nl_str);
      puts(temp);
      puts(" invalid symbols skipped.\n");
      }
   if (!num_syms)
      puts("No symbols to load!\n");
   else
      {
      itoa(num_syms,temp);
      puts(temp);
      puts(num_sym_msg);
      puts(nl_str);
      if (num_syms == SYM_TABLE_SIZE)
         {
         puts(sym_tab_full_msg);
         puts(nl_str);
         }
      qsort(symbols,num_syms,sizeof(struct symbol_table),compare_sym_addr);
      }
   pressany(FALSE);
   }

int lookup_sym(seg,ofs)
   unsigned int seg,ofs;
   {
   int min, max, middle, i;
   struct symbol_table s;

   min = 0;
   max = num_syms - 1;
   s.seg = seg;
   s.ofs = ofs;
   do
      {
      middle = (min + max) / 2;
      if ((i = compare_sym_addr(&symbols[middle],&s)) == 0)
         return(middle);
      if (i > 0)
         max = middle - 1;
      else
         min = middle + 1;
      } while (min <= max);
   return(-1);
   }

void save_symbols()
   {
   int count,i,mygetsval;
   char tempstr[150];

   cls();
   puts("Write symbol file:");
   if (!num_syms)
      {
      putsat(2,0,"There are no symbols to save.");
      pressany(FALSE);
      return;
      }
   while (1)
      {
      strcpy(tempstr,filename);
      for (count = 0; count < strlen(tempstr); count++)
         if (tempstr[count] == '.')
            tempstr[count] = '\0';
      strcat(tempstr,".SYM");
      clear_to_bottom(2,0);
      putsat(2,0,"Press Return for ");
      puts(tempstr);
      puts(",");
      if ((mygetsval = get_answer(3,0,TRUE,"or enter the symbol filename? ",esc_to_quit_msg,globalstr)) < 0)
         if (mygetsval == -1)
            return;
         else
            continue;
      if (globalstr[0])
         strcpy(tempstr,globalstr);
      if ((fileout = open(tempstr,MODE_READ)) != -1)
         {
         close(fileout);
         puts("\nThe symbol file already exists.\n");
         puts("Do you wish to overwrite it (Y, N, or Return to quit)? ");
         do
            {
            curpos(6,55);
            mygets(globalstr);
            if (globalstr[0] == '\0')
               return;
            globalstr[0] = toupper(globalstr[0]);
            if ((globalstr[0] != 'Y') && (globalstr[0] != 'N'))
               {
               clear_to_bottom(6,55);
               puts(ill_resp_msg);
               }
            else
               clear_to_bottom(7,0);
            } while ((globalstr[0] != 'Y') && (globalstr[0] != 'N'));
         if (globalstr[0] == 'N')
            continue;
         }
      fileout = fopen(tempstr,"w");
      for (i = 0; i < num_syms; i++)
         {
         itox(symbols[i].seg,tempstr);
         tempstr[4] = ':';
         itox(symbols[i].ofs,&tempstr[5]);
         tempstr[9] = ' ';
         tempstr[10] = '\0';
         strcat(tempstr,symbols[i].sym);
         strcat(tempstr,nl_str);
         fputs(tempstr,fileout);
         }
      fclose(fileout);
      return;
      }
   }

preview_file()
   {
   int mygetsval;
   unsigned int preview_start, temp, use_data_seg;
   char byte;

   cls();
   puts("Preview Disassembled file:");
   linecount =
   preview_start = 0;
   putsat(2,0,start_loc_msg);
   do
      {
      temp = FALSE;
      if ((mygetsval = get_answer(3,0,TRUE,start_loc_2_msg,esc_to_quit_msg,globalstr)) < 0)
         if (mygetsval == -1)
            return;
         else
            {
            globalstr[0] = TRUE;  /* to continue with the next iteration */
            continue;
            }
      if ((globalstr[0]) && ((temp = numval(globalstr,&preview_start)) == FALSE))
         {
         clear_to_bottom(3,49);
         putsat(5,0,ill_addr_msg);
         }
      } while ((globalstr[0]) && (!temp));
   if (get_answer(5,0,FALSE,"Do you want to pause on page boundaries? (Y/N, Return = No) ",
                               esc_to_quit_msg,globalstr) == -1)
       return;
   pagepause = (toupper(globalstr[0]) == 'Y');
   use_data_seg = FALSE;
   if ((preview_start) && (file_type == TYPE_EXE))
      {
      do
         {
         if ((mygetsval = get_answer(7,0,TRUE,which_seg_msg,esc_to_quit_msg,globalstr)) < 0)
            if (mygetsval == -1)
               return;
            else
               {
               byte = TRUE;  /* to continue with the next iteration */
               continue;
               }
         if (!globalstr[0])
            globalstr[0] = 'C';
         byte = toupper(globalstr[0]);
         if (byte == 'D')
            use_data_seg = TRUE;
         else
            if (byte != 'C')
               {
               clear_to_bottom(7,33);
               puts(ill_resp_msg);
               }
          } while ((byte != 'D') && (byte != 'C'));
      clear_to_bottom(8,0);
      }
   create_disassembled_file(TRUE,preview_start,progend,use_data_seg);
   if (myfputsok != -1)
      {
      puts("\n\nPress any key to return to the menu...");
      check_key();
      }
   }

locate_string()
   {
   int mygetsval;
   unsigned int locate_start, endloc, temp, temp2, use_data_seg;
   char byte;

   cls();
   puts("Locate string in disassembled file:");
   pagepause = FALSE;
   linecount =
   locate_start = 0;
/*
Note that the following prompt string is a multiple of 8 characters in length.
*/
   if (get_answer(2,0,FALSE,"Enter the string to search for? ",
                        esc_to_quit_msg,search_str) == -1)
      return;
   strlwr(search_str);
   putsat(4,0,start_loc_msg);
   do
      {
      temp = FALSE;
      if ((mygetsval = get_answer(5,0,TRUE,start_loc_2_msg,esc_to_quit_msg,globalstr)) < 0)
         if (mygetsval == -1)
            return;
         else
            {
            globalstr[0] = TRUE;  /* to continue with the next iteration */
            continue;
            }
      if ((globalstr[0]) && ((temp = numval(globalstr,&locate_start)) == FALSE))
         {
         clear_to_bottom(5,49);
         putsat(7,0,ill_addr_msg);
         }
      } while ((globalstr[0]) && (!temp));
   endloc = progend;
   putsat(7,0,end_loc_msg);
   do
      {
      temp2 = FALSE;
      if ((mygetsval = get_answer(8,0,TRUE,end_loc_msg_2,esc_to_quit_msg,globalstr)) < 0)
         if (mygetsval == -1)
            return;
         else
            {
            globalstr[0] = TRUE;  /* to continue with the next iteration */
            continue;
            }
      if ((globalstr[0]) && ((temp2 = numval(globalstr,&temp)) == FALSE))
         {
         clear_to_bottom(8,52);
         putsat(10,0,ill_addr_msg);
         }
      } while ((globalstr[0]) && (!temp2));
   if ((globalstr[0]) && (temp2) && (temp))
      endloc = temp;
   use_data_seg = FALSE;
   if (((locate_start) || (endloc != progend)) && (file_type == TYPE_EXE))
      {
      do
         {
         if ((mygetsval = get_answer(10,0,TRUE,which_seg_msg,esc_to_quit_msg,globalstr)) < 0)
            if (mygetsval == -1)
               return;
            else
               {
               byte = TRUE;  /* to continue with the next iteration */
               continue;
               }
         if (!globalstr[0])
            globalstr[0] = 'C';
         byte = toupper(globalstr[0]);
         if (byte == 'D')
            use_data_seg = TRUE;
         else
            if (byte != 'C')
               {
               clear_to_bottom(10,33);
               puts(ill_resp_msg);
               }
          } while ((byte != 'D') && (byte != 'C'));
      clear_to_bottom(11,0);
      }
   find_str_len = 0;  /* clear the string */
   string_search = TRUE;
   create_disassembled_file(TRUE,locate_start,endloc,use_data_seg);
   string_search = FALSE;
   if (!string_found)
      puts("\n\nNo matching strings found.");
   puts("\n\nPress any key to return to the menu...");
   string_found = FALSE;  /* for next time through */
   check_key();
   }

void write_file()
   {
   int i, mygetsval;
   unsigned int count, startloc, endloc, temp, temp2, use_data_seg;
   char byte;

   do
      {
      pagepause = FALSE;
      linecount = 0;
      strcpy(outfile,filename);
      for (count = 0; count < strlen(outfile); count++)
         if (outfile[count] == '.')
            outfile[count] = '\0';
      strcat(outfile,".CG");
      cls();
      puts("Write Disassembled file:");
      byte = 'N';   /* default to no overwrite */
      putsat(2,0,"Press Return for ");
      puts(outfile);
      puts(",");
      if ((mygetsval = get_answer(3,0,TRUE,"or enter the output filename? ",esc_to_quit_msg,globalstr)) < 0)
         if (mygetsval == -1)
            return;
         else
            continue;
      strupr(globalstr);
      if (globalstr[0])
         strcpy(outfile,globalstr);
      byte = 'Y';  /* have a name, see if it exists */
      count = 5;  /* use for location of messages */
      if ((i = open(outfile,MODE_READ)) != -1)
         {
         close(i);
         do
            {
            clear_to_bottom(5,0);
            putsat(5,0,"The file ");
            puts(outfile);
            puts(" already exists.\nDo you wish to over-write it (Y/N or Return to quit)? ");
            mygets(globalstr);
            byte = toupper(globalstr[0]);
            if (byte == '\0')
               return;
            } while ((byte != 'Y') && (byte != 'N'));
         count = 8;
         }
      } while (byte != 'Y');
   endloc = progend;
   startloc = 0;
   putsat(count,0,start_loc_msg);
   count++;
   do
      {
      temp = FALSE;
      if ((mygetsval = get_answer(count,0,TRUE,start_loc_2_msg,esc_to_quit_msg,globalstr)) < 0)
         if (mygetsval == -1)
            return;
         else
            {
            globalstr[0] = TRUE;  /* to continue with the next iteration */
            continue;
            }
      if ((globalstr[0]) && ((temp = numval(globalstr,&startloc)) == FALSE))
         {
         clear_to_bottom(count,49);
         putsat(count+2,0,ill_addr_msg);
         }
      } while ((globalstr[0]) && (!temp));
   putsat(count+2,0,end_loc_msg);
   count += 3;
   do
      {
      temp2 = FALSE;
      if ((mygetsval = get_answer(count,0,TRUE,end_loc_msg_2,esc_to_quit_msg,globalstr)) < 0)
         if (mygetsval == -1)
            return;
         else
            {
            globalstr[0] = TRUE;  /* to continue with the next iteration */
            continue;
            }
      if ((globalstr[0]) && ((temp2 = numval(globalstr,&temp)) == FALSE))
         {
         clear_to_bottom(count,52);
         putsat(count+2,0,ill_addr_msg);
         }
      } while ((globalstr[0]) && (!temp2));
   if ((globalstr[0]) && (temp2) && (temp))
      endloc = temp;
   use_data_seg = FALSE;
   if (((startloc) || (endloc != progend)) && (file_type == TYPE_EXE))
      {
      count += 2;
      do
         {
         if ((mygetsval = get_answer(count,0,TRUE,which_seg_msg,esc_to_quit_msg,globalstr)) < 0)
            if (mygetsval == -1)
               return;
            else
               {
               byte = TRUE;  /* to continue with the next iteration */
               continue;
               }
         if (!globalstr[0])
            globalstr[0] = 'C';
         byte = toupper(globalstr[0]);
         if (byte == 'D')
            use_data_seg = TRUE;
         else
            if (byte != 'C')
               {
               clear_to_bottom(count,33);
               puts(ill_resp_msg);
               }
          } while ((byte != 'D') && (byte != 'C'));
      clear_to_bottom(count+1,0);
      }
   if ((!startloc) && (endloc == progend))
      {
      putsat(count+2,0,"Do you want to generate a cross reference (Y/N, Return = No)? ");
      if (mygets(globalstr) == -1)
         return;
      if (toupper(globalstr[0]) == 'Y')
         {
         do_xref = TRUE;
         putsat(count+4,0,"Do you want to ignore \"near\" cross references (Y/N, Return = No)? ");
         if (mygets(globalstr) == -1)
            return;
         if (toupper(globalstr[0]) == 'Y')
            {
            putsat(count+6,0,"Ignore cross references in the range 0 - xxxx (hex)? ");
            if (mygets(globalstr) == -1)
               return;
            if ((globalstr[0]) && (numval(globalstr,&temp) == TRUE))
               {
               skip_short_xref = TRUE;
               skip_short_xref_dist = temp;
               }
            }
         }
      }
   create_disassembled_file(FALSE,startloc,endloc,use_data_seg);
   }
