/*
   This file is copyright (c) 1986, 1987 by William Couture.  All rights reserved.
*/


/*
   This file should be fairly self-explanatory.

   The order of the opnames is that of their definition in OPDEFS.H,
   and the index number of the instruction name is the #define number,
   and the array of pointers to functions defined in fns.c is also
   keyed to this order.  If you change ANY of them, YOU NEED TO CHANGE
   THEM ALL!


   DOS function names added for CODEGEN, V1.1.

   80286 PM instruction names added for CODEGEN, V1.2
*/

char opnames[129][7] = {
"DB"    ,"AAA"   ,"AAD",   "AAM",
"AAS",   "ADC",   "ADD",   "AND",
/*
"BOUND", "CALL",  "CALLF", "CBW",
*/
"BOUND", "CALL",  "CALL",  "CBW",     /* CODEGEN */
"CLC",   "CLD",   "CLI",   "CMC",
"CMP",   "CMPSB", "CMPSW", "CWD",
"DAA",   "DAS",   "DEC",   "DIV",
"ENTER", "ESC",   "HLT",   "IDIV",
"IMUL",  "IN",    "INC",   "INSB",
"INSW",  "INT",   "INTO",  "IRET",
"JA",    "JAE",   "JCXZ",  "JG",
/*
"JGE",   "JMP",   "JMPF",  "JNA",
*/
"JGE",   "JMP",   "JMP",   "JNA",     /* CODEGEN */
"JNAE",  "JNG",   "JNGE",  "JNO",
"JNS",   "JNZ",   "JO",    "JPE",
"JPO",   "JS",    "JZ",    "LAHF",
"LDS",   "LEA",   "LEAVE", "LES",
"LOCK",  "LODSB", "LODSW", "LOOP",
"LOOPNZ","LOOPZ", "MOV",   "MOVSB",
"MOVSW", "MUL",   "NEG",   "NOP",
"NOT",   "OR",    "OUT",   "OUTSB",
"OUTSW", "POP",   "POPA",  "POPF",
"PUSH",  "PUSHA", "PUSHF", "RCL",
"RCR",   "REPZ",  "REPNZ", "RET",
"RETF",  "ROL",   "ROR",   "SAHF",
"SAR",   "SBB",   "SCASB", "SCASW",
"CS:",   "DS:",   "ES:",   "SS:",  /* these are here because of the names 
                                      SEG CS, etc. */
"SHL",   "SHR",   "STC",   "STD",
"STI",   "STOSB", "STOSW", "SUB",
"TEST",  "WAIT",  "XCHG",  "XLAT",
"XOR",
/*
   80286 PM instructions, not in alphabetical order
*/
"ARPL",  "SLDT",  "STR",   "LLDT",
"LTR",   "VERR",  "VERW",  "SGDT",
"SIDT",  "LGDT",  "LIDT",  "SMSW",
"LMSW",  "LAR",   "LSL",   "CLTS"
   };

/*  Note that register names are defined in opcode order */
char regnames[23][3] = {
"AX","CX","DX","BX","SP","BP","SI","DI","ES","CS","SS","DS","","AL","AX",
"AL","CL","DL","BL","AH","CH","DH","BH"
   };

/*
char flagnames[2][9][3] = 
   {
      {"NV","UP","DI","NT","PL","NZ","NA","PO","NC"},
      {"OV","DN","EI","TR","NG","ZR","AC","PE","CY"}
   };
*/

char *equiv_jmp_names[19] = {  /* NOTE: indexed by instruction.name-JA */
/* JA   */   "JNBE",
/* JAE  */   "JNC/JNB",
/* JCXZ */   "",
/* JG   */   "JNLE",
/* JGE  */   "JNL",
/* JMP  */   "",
/* JMPF */   "",
/* JNA  */   "JBE",
/* JNAE */   "JC/JB",
/* JNG  */   "JLE",
/* JNGE */   "JL",
/* JNO  */   "",
/* JNS  */   "",
/* JNZ  */   "JNE",
/* JO   */   "",
/* JPE  */   "JP",
/* JPO  */   "JNP",
/* JS   */   "",
/* JZ   */   "JE"
};

char *dos_fn_names[0x69] = {        /* INT 21 */
/* 0x00 */ "TERMINATE PROGRAM",
/* 0x01 */ "KEYBOARD INPUT",
/* 0x02 */ "WRITE CHAR",
/* 0x03 */ "AUX INPUT",
/* 0x04 */ "AUX OUTPUT",
/* 0x05 */ "PRINTER OUTPUT",
/* 0x06 */ "DIRECT CONSOLE I/O",
/* 0x07 */ "DIRECT CON I/O NOECHO",
/* 0x08 */ "CONSOLE INPUT NO ECHO",
/* 0x09 */ "PRINT STRING",
/* 0x0a */ "INPUT STRING",
/* 0x0b */ "CHECK INPUT STATUS",
/* 0x0c */ "CLEAR KEYBOARD, CALL FUNCTION",
/* 0x0d */ "DISK RESET",
/* 0x0e */ "SELECT DISK",
/* 0x0f */ "FCB OPEN FILE",
/* 0x10 */ "FCB CLOSE FILE",
/* 0x11 */ "FCB FIND FIRST",
/* 0x12 */ "FCB FIND NEXT",
/* 0x13 */ "FCB DELETE FILE",
/* 0x14 */ "FCB SEQUENTIAL READ",
/* 0x15 */ "FCB SEQUENTIAL WRITE",
/* 0x16 */ "FCB CREATE FILE",
/* 0x17 */ "FCB RENAME FILE",
/* 0x18 */ "RESERVED (NULL)",
/* 0x19 */ "GET CURRENT DISK",
/* 0x1a */ "SET DTA",
/* 0x1b */ "GET ALLOCATION INFO",
/* 0x1c */ "GET ALLOCATION FOR DRIVE",
/* 0x1d */ "RESERVED (NULL)",
/* 0x1e */ "RESERVED (NULL)",
/* 0x1f */ "GET PTR TO DRIVE INFO",
/* 0x20 */ "RESERVED (NULL)",
/* 0x21 */ "FCB RANDOM READ",
/* 0x22 */ "FCB RANDOM WRITE",
/* 0x23 */ "FCB FILE SIZE",
/* 0x24 */ "FCB SET RELATIVE RECORD",
/* 0x25 */ "SET INTERRUPT VECTOR",
/* 0x26 */ "CREATE NEW PSP",
/* 0x27 */ "FCB RANDOM BLOCK READ",
/* 0x28 */ "FCB RANDOM BLOCK WRITE",
/* 0x29 */ "PARSE FILENAME",
/* 0x2a */ "GET DATE",
/* 0x2b */ "SET DATE",
/* 0x2c */ "GET TIME",
/* 0x2d */ "SET TIME",
/* 0x2e */ "SET/RESET VERIFY",
/* 0x2f */ "GET DTA",
/* 0x30 */ "GET DOS VERSION",
/* 0x31 */ "TERM. & STAY RESIDENT",
/* 0x32 */ "GET PTR TO DRIVE INFO",
/* 0x33 */ "CTRL-BREAK CHECK",
/* 0x34 */ "GET PTR TO DOS CRITICAL FLAG",
/* 0x35 */ "GET INTERRUPT VECTOR",
/* 0x36 */ "GET DISK FREE SPACE",
/* 0x37 */ "GET/SET SWITCH CHAR",
/* 0x38 */ "GET/SET COUNTRY INFO",
/* 0x39 */ "CREATE DIR (MKDIR)",
/* 0x3a */ "REMOVE DIR (RMDIR)",
/* 0x3b */ "CHANGE DIR (CHDIR)",
/* 0x3c */ "CREATE FILE",
/* 0x3d */ "OPEN FILE",
/* 0x3e */ "CLOSE FILE",
/* 0x3f */ "READ FILE",
/* 0x40 */ "WRITE TO FILE",
/* 0x41 */ "DELETE FILE",
/* 0x42 */ "MOVE FILE PTR (LSEEK)",
/* 0x43 */ "GET/SET FILE ATTRIBUTES",
/* 0x44 */ "IOCTL FUNCTIONS",
/* 0x45 */ "DUPLICATE HANDLE",
/* 0x46 */ "FORCE DUP HANDLE",
/* 0x47 */ "GET CURRENT DIRECTORY",
/* 0x48 */ "ALLOCATE MEMORY",
/* 0x49 */ "FREE ALLOCATED MEMORY",
/* 0x4a */ "MODIFY ALLOCATED MEMORY",
/* 0x4b */ "LOAD/EXECUTE PROGRAM",
/* 0x4c */ "TERMINATE PROGRAM",
/* 0x4d */ "GET RETURN CODE",
/* 0x4e */ "FIND FIRST",
/* 0x4f */ "FIND NEXT",
/* 0x50 */ "SET PSP ADDRESS",
/* 0x51 */ "GET PSP ADDRESS",
/* 0x52 */ "GET PTR TO DEVICE DRIVER CHAIN",
/* 0x53 */ "LOG NEW DRIVE INFO",
/* 0x54 */ "GET VERIFY FLAG",
/* 0x55 */ "CREATE CHILD PSP",
/* 0x56 */ "RENAME (MOVE) A FILE",
/* 0x57 */ "GET/SET FILE TIME/DATE",
/* 0x58 */ "GET/SET MEMORY ALLOC. STRATEGY",
/* 0x59 */ "GET EXTENDED ERROR",
/* 0x5a */ "CREATE UNIQUE FILE",
/* 0x5b */ "CREATE NEW FILE",
/* 0x5c */ "(UN)LOCK FILE ACCESS",
/* 0x5d */ "SET EXTENDED ERROR INFO",
/* 0x5e */ "NETWORK FUNCTIONS",
/* 0x5f */ "NETWORK REDIRECTION",
/* 0x60 */ "BUILD FULL PATHNAME TO FILE",
/* 0x61 */ "RESERVED (NULL)",
/* 0x62 */ "GET PSP",
/* 0x63 */ "RESERVED (NULL)",
/* 0x64 */ "UNKNOWN DOS CALL",
/* 0x65 */ "GET EXTENDED COUNTRY INFO",
/* 0x66 */ "GET/SET GLOBAL CODE PAGE",
/* 0x67 */ "SET HANDLE COUNT",
/* 0x68 */ "COMMIT FILE"
};

char *video_fn_names[0x1d] = {      /* INT 10 */
/* 0x00 */ "SET SCREEN MODE",
/* 0x01 */ "SET CURSOR TYPE",
/* 0x02 */ "SET CURSOR POSITION",
/* 0x03 */ "GET CURSOR POSITION",
/* 0x04 */ "READ LIGHT PEN POS",
/* 0x05 */ "SELECT ACTIVE PAGE",
/* 0x06 */ "SCROLL ACTIVE PAGE UP",
/* 0x07 */ "SCROLL ACTIVE PAGE DOWN",
/* 0x08 */ "GET CHAR & ATTRIBUTE",
/* 0x09 */ "WRITE CHAR & ATTRIB",
/* 0x0a */ "WRITE CHAR",
/* 0x0b */ "SET COLOR PALETTE",
/* 0x0c */ "WRITE PIXEL",
/* 0x0d */ "READ PIXEL",
/* 0x0e */ "WRITE CHAR, MOVE CURSOR",
/* 0x0f */ "GET VIDEO MODE",
/* 0x10 */ "SET PALETTE REGS",
/* 0x11 */ "CHAR GENERATOR FUNCTIONS",
/* 0x12 */ "ALTERNATE FUNCTION SELECT",
/* 0x13 */ "WRITE STRING",
/* 0x14 */ "CNVERT: LOAD LCD CHAR FONT",
/* 0x15 */ "CNVERT: GET PHYS DISP PARAMS",
/* 0x16 */ "RESERVED",
/* 0x17 */ "RESERVED",
/* 0x18 */ "RESERVED",
/* 0x19 */ "RESERVED",
/* 0x1a */ "GET/SET DISPLAY COMBINATION",
/* 0x1b */ "GET FUNCTIONALITY/STATE INFO",
/* 0x1c */ "SAVE/RESTORE VIDEO STATE"
};

char *disk_fn_names[0x18] = {    /* INT 13 */
/* 0x00 */ "RESET DISKS",
/* 0x01 */ "GET DISK STATUS",
/* 0x02 */ "READ SECTORS",
/* 0x03 */ "WRITE SECTORS",
/* 0x04 */ "VERIFY SECTORS",
/* 0x05 */ "FORMAT TRACK",
/* 0x06 */ "FLAG HD BADTRACK?",
/* 0x07 */ "FORMAT HARD DISK?",
/* 0x08 */ "GET DRIVE PARAMETERS",
/* 0x09 */ "INIT PARAMETER TABLES",
/* 0x0a */ "READ LONG (ECC)",
/* 0x0b */ "WRITE LONG (ECC)",
/* 0x0c */ "SEEK TO CYLINDER",
/* 0x0d */ "RESET HARD DISKS",
/* 0x0e */ "READ CONTROLLER'S SECTOR BUF?",
/* 0x0f */ "WRITE CONTROLLER'S SECTOR BUF?"
/* 0x10 */ "TEST FOR DRIVE READY",
/* 0x11 */ "RECALIBRATE TO TRACK 0",
/* 0x12 */ "CONTROLLER RAM DIAGNOSTICS?",
/* 0x13 */ "DRIVE TEST DIAGNOSTICS?",
/* 0x14 */ "CONTROLLER DIAGNOSTICS",
/* 0x15 */ "GET DISK TYPE",
/* 0x16 */ "GET DISK CHANGE",
/* 0x17 */ "SET DISK TYPE"
};

char *serial_fn_names[4] = {      /* INT 14 */
/* 0 */ "INITALIZE USART",
/* 1 */ "TRANSMIT CHARACTER",
/* 2 */ "RECEIVE CHARACTER",
/* 3 */ "GET USART STATUS"
};

char *cassette_fn_names[4] = {       /* INT 15 */
/* 0 */ "CASSETTE MOTOR ON",
/* 1 */ "CASSETTE MOTOR OFF",
/* 2 */ "READ CASSETTE",
/* 3 */ "WRITE CASSETTE"
};

char *atbios_fn_names[0x12] = {       /* INT 15 */
/* 0x80 */ "DEVICE OPEN",
/* 0x81 */ "DEVICE CLOSE",
/* 0x82 */ "DEVICE PROGRAM TERMINATION",
/* 0x83 */ "EVENT WAIT",
/* 0x84 */ "READ JOYSTICK",
/* 0x85 */ "SYSREQ KEY PRESS",
/* 0x86 */ "WAIT",
/* 0x87 */ "MOVE EXTENDED MEMORY BLOCK",
/* 0x88 */ "GET EXTENDED MEMORY SIZE",
/* 0x89 */ "SWITCH TO VIRTUAL MODE",
/* 0x8a */ "RESERVED",
/* 0x8b */ "RESERVED",
/* 0x8c */ "RESERVED",
/* 0x8d */ "RESERVED",
/* 0x8e */ "RESERVED",
/* 0x8f */ "RESERVED",
/* 0x90 */ "DEVICE BUSY LOOP",
/* 0x91 */ "FINISH INTERRUPT"
};

char *keyboard_fn_names[0x13] = {       /* INT 16 */
/* 0x00 */ "GET CHARACTER",
/* 0x01 */ "CHECK KEYBOARD",
/* 0x02 */ "GET SHIFT STATUS",
/* 0x03 */ "SET REPEAT RATE&DELAY",
/* 0x04 */ "RESERVED",
/* 0x05 */ "PUT KEYSTROKE INTO BUF",
/* 0x06 */ "RESERVED",
/* 0x07 */ "RESERVED",
/* 0x08 */ "RESERVED",
/* 0x09 */ "RESERVED",
/* 0x0a */ "RESERVED",
/* 0x0b */ "RESERVED",
/* 0x0c */ "RESERVED",
/* 0x0d */ "RESERVED",
/* 0x0e */ "RESERVED",
/* 0x0f */ "RESERVED",
/* 0x10 */ "101KEY: GET CHARACTER",
/* 0x11 */ "101KEY: CHECK KEYBOARD",
/* 0x12 */ "101KEY: GET SHIFT STATUS"
};

char *parallel_fn_names[3] = {       /* INT 17 */
/* 0 */ "PRINT CHARACTER",
/* 1 */ "INITALIZE PRINTER",
/* 2 */ "GET PRINTER STATUS"
};

char *timer_fn_names[8] = {       /* INT 1a */
/* 0x00 */ "GET TIME-OF-DAY",
/* 0x01 */ "SET TIME-OF-DAY",
/* 0x02 */ "READ CMOS TIME",
/* 0x03 */ "SET CMOS TIME",
/* 0x04 */ "READ CMOS DATE",
/* 0x05 */ "SET CMOS DATE",
/* 0x06 */ "SET ALARM",
/* 0x07 */ "RESET ALARM"
};

char *mouse_fn_names[0x1f] = {      /* INT 33 */
/* 0x0000 */ "RESET DRIVER, READ STATUS",
/* 0x0001 */ "SHOW MOUSE CURSOR"
/* 0x0002 */ "HIDE MOUSE CURSOR",
/* 0x0003 */ "GET POSITION & BUTTON STATUS",
/* 0x0004 */ "POSITION MOUSE CURSOR",
/* 0x0005 */ "GET BUTTON PRESS DATA",
/* 0x0006 */ "GET BUTTON RELEASE DATA",
/* 0x0007 */ "SET HORIZ CUROSR RANGE",
/* 0x0008 */ "SET VERT CURSOR RANGE",
/* 0x0009 */ "DEFINE GRAPHICS CURSOR",
/* 0x000a */ "DEFINE TEXT CURSOR",
/* 0x000b */ "READ MOTION COUNTERS",
/* 0x000c */ "DEFINE INTR SUBR PARMS",
/* 0x000d */ "LIGHT PEN EMULATE ON",
/* 0x000e */ "LIGHT PEN EMULATE OFF",
/* 0x000f */ "SET MICKEY/PIXEL RATIO",
/* 0x0010 */ "SET SCREEN REGION FOR UPDATE",
/* 0x0011 */ "RESERVED",
/* 0x0012 */ "RESERVED",
/* 0x0013 */ "SET DOUBLE-SPEED THRESHOLD",
/* 0x0014 */ "XCHG INTERRUPT SUBROUTINES",
/* 0x0015 */ "GET DRIVER STORAGE REQUIRED",
/* 0x0016 */ "SAVE DRIVER STATE",
/* 0x0017 */ "RESTORE DRIVER STATE",
/* 0x0018 */ "RESERVED",
/* 0x0019 */ "RESERVED",
/* 0x001a */ "RESERVED",
/* 0x001b */ "RESERVED",
/* 0x001c */ "RESERVED",
/* 0x001d */ "SET DISPLAY PAGE NUMBER",
/* 0x001e */ "GET DISPLAY PAGE NUMBER"
};

char *emm_fn_names[0x1e] = {       /* INT 67 */
/* 0x40 */ "GET EMM STATUS",
/* 0x41 */ "GET FRAME SEGMENT ADDRESS",
/* 0x42 */ "GET AVAILABLE PAGE COUNT",
/* 0x43 */ "ALLOCATE PAGES",
/* 0x44 */ "(UN)MAP HANDLE PAGE",
/* 0x45 */ "DEALLOCATE PAGES",
/* 0x46 */ "GET EMM VERSION",
/* 0x47 */ "SAVE PAGE MAP",
/* 0x48 */ "RESTORE PAGE MAP",
/* 0x49 */ "RESERVED",
/* 0x4a */ "RESERVED",
/* 0x4b */ "GET HANDLE COUNT",
/* 0x4c */ "GET HANDLE PAGES",
/* 0x4d */ "GET ALL HANDLE PAGES",
/* 0x4e */ "GET/SET PAGE MAP",
/* 0x4f */ "GET/SET PARTIAL PAGE MAP",
/* 0x50 */ "(UN)MAP MULTIPLE HANDLE PAGES",
/* 0x51 */ "REALLOCATE PAGES",
/* 0x52 */ "GET/SET HANDLE ATTRIBUTES",
/* 0x53 */ "GET/SET HANDLE NAME",
/* 0x54 */ "HANDLE DIRECTORY FUNCTIONS",
/* 0x55 */ "ALTER PAGE MAP & JUMP",
/* 0x56 */ "ALTER PAGE MAP & CALL",
/* 0x57 */ "MOVE/XCHNG MEMORY REGION",
/* 0x58 */ "GET MAPPABLE PHYS. ADDR. ARRAY",
/* 0x59 */ "GET EMM HARDWARE INFO",
/* 0x5a */ "ALLOCATE PAGES",
/* 0x5b */ "ALTERNATE MAP FUNCTIONS",
/* 0x5c */ "PREPARE FOR WARMBOOT",
/* 0x5d */ "OPERATING SYSTEM FUNCTIONS"
};



/*     p = "REVECTORED FLOPPY BIO"; */  /* for string length check */
