/*
   This file is copyright (c) 1986 by William Couture.  All rights reserved.
*/


/*
   NOTE:  These unions will ONLY work on a machine that uses least significant
          byte first, and has a 2 byte unsigned integer with a 1 byte unsigned
          char!

   YOU HAVE BEEN WARNED!

   Modifed for CODEGEN, V1.3
*/

union axreg
   {
   unsigned int word;
   struct 
      {
      unsigned char al;
      unsigned char ah;
      } byte;
   };
/*
   Note that the only difference between the AX, BX, CX, and DX register
   unions is the names of the byte variables.
*/

union bxreg
   {
   unsigned int word;
   struct 
      {
      unsigned char bl;
      unsigned char bh;
      } byte;
   };

union cxreg
   {
   unsigned int word;
   struct 
      {
      unsigned char cl;
      unsigned char ch;
      } byte;
   };

union dxreg
   {
   unsigned int word;
   struct 
      {
      unsigned char dl;
      unsigned char dh;
      } byte;
   };

struct regstruct
   {
   union axreg ax;  /* Note that registers are in opcode order */
   union cxreg cx;
   union dxreg dx;
   union bxreg bx;
   unsigned int sp;
   unsigned int bp;
   unsigned int si;
   unsigned int di;
   unsigned int es;
   unsigned int cs;
   unsigned int ss;
   unsigned int ds;
   unsigned int flag;
   unsigned int ip;
   };
/*
   Note:  I originally planned on stopping at the above structure definition,
   but I was faced with the problem of addressing the byte and word registers
   without resorting to a case statement or some such, and thus both the
   union below and the mixbytereg array used in decode() and decodens() had
   to be added.

   This must be a union and not individual data structures, or else there is
   the problem of which version is current (YUCK!)
*/

union regunion
   {
   struct regstruct r;
   unsigned char bytearray[28];  /* actually, this could be bytearray[8] */
   unsigned int wordarray[14];
   };  /* but you never know when I might have made a mistake */

union regflags
   {
   unsigned int wordknown[14];
/* ax cx dx bx sp bp si di es cs ss ds flags ip
    0  1  2  3  4  5  6  7  8  9 10 11  12   13 */
   unsigned char byteknown[8];
/* al ah cl ch dl dh bl bh
    0  1  2  3  4  5  6  7   regs.bytearray order */
   };
